jQuery(document).ready(function() {

	jQuery('.dataTable').dataTable({
	
		"ordering" : false,
	
	});
	
	jQuery('.dataTable-DBInvoice').dataTable({
	
		"order": [[ 0, 'desc' ]],
	
	});
	
	jQuery('.dt-tk').dataTable({
	
		"ordering": false,
	
	});
	
	jQuery('.dt-st').dataTable({
	
		"ordering": false,
	
	});
	
	jQuery('.masonry-grid').masonry({
	  
	  itemSelector: '.grid-item',
	  
	  gutterWidth: 20,
	  
	});
	


	jQuery('.add_timer').on('click', function(e) {
	
		e.preventDefault();
		
		var task_id = jQuery(this).val();

		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#add-time-div',							

			'opacity': '0.5',	
			
			'overlayClose'  : false, 
				
			'escKey' : false,
			
			'onCleanup' : function() {
			
				jQuery('.timer').timer('remove');
			
			}
			
		});	
		
		jQuery.colorbox.resize();	

		jQuery('#task' + task_id).attr('selected', 'selected');
	
	});

	jQuery('#create_linked_team').on('click', function(e) {
	
		e.preventDefault();
		
		var user_id = jQuery(this).data('uid');
		
		var spinner = jQuery('#spinner_1');
	
		var data = {
		
			'action' : 'cqpim_create_team_from_admin',
			
			'user_id' : user_id,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#create_linked_team').prop('disabled', true);

			},

		}).done(function(response){
		
			if(response.error == true) {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#create_linked_team').prop('disabled', false);
				
				alert('Something went wrong, pleae check your WordPress account to make sure the Display Name field has been completed. Then try again.');
				
			} else {

				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#create_linked_team').prop('disabled', false);
				
				location.reload();
			
			}

		});	
	
	});
    
	jQuery('.colorbox').on('click', function(e) {
	
		e.preventDefault();
	
		var anc = jQuery(this).attr('href');
		
		var id = anc.replace('#', '');
		
		var thediv = jQuery('#' + id);
		
		jQuery(thediv).parent('div').attr('id', id + '_container');
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#' + id,
			
			'opacity': '0.5',
			
		});	
	
	});

	jQuery('body').on('focus',".datepicker", function(){
	
		jQuery(this).datepicker({ dateFormat: 'dd/mm/yy' });
	
	});	
	
	// Delete Time Entry
	
	jQuery('.time_remove').live('click', function(e) {
	
		e.preventDefault();
		
		var task_id = jQuery(this).data('task');
		
		var key = jQuery(this).data('key');
		
		var element = jQuery(this);
		
		var domain = document.domain;
		
		var spinner = jQuery('#ajax_spinner_remove_time_' + task_id);
		
		var data = {
		
			'action' : 'cqpim_remove_time_entry',
			
			'task_id' : task_id,
			
			'key' : key
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

				jQuery('a.time_remove').prop('disabled', true);
				
				jQuery.colorbox.resize();

			},
			
		}).done(function(response){
					
			if(response.error == true) {
			
			spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('a.time_remove').prop('disabled', false);

				
			} else {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('a.time_remove').prop('disabled', false);
				
				jQuery(element).parents('li').fadeOut('slow');
				
				jQuery(element).parents('li').remove();
				
				jQuery.colorbox.resize();
				
			
			}				

		});
	
	});

	var hasTimer = false;
	// Init timer start
	jQuery('.start-timer-btn').on('click', function() {
		hasTimer = true;
		jQuery('.timer').timer({
			editable: false,
			format: '%H:%M:%S' 
		});
		jQuery(this).addClass('hidden');
		jQuery('.pause-timer-btn, .remove-timer-btn').removeClass('hidden');
	});

	// Init timer resume
	jQuery('.resume-timer-btn').on('click', function() {
		jQuery('.timer').timer('resume');
		jQuery(this).addClass('hidden');
		jQuery('.pause-timer-btn, .remove-timer-btn').removeClass('hidden');
	});


	// Init timer pause
	jQuery('.pause-timer-btn').on('click', function() {
		jQuery('.timer').timer('pause');
		jQuery(this).addClass('hidden');
		jQuery('.resume-timer-btn').removeClass('hidden');
	});

	// Remove timer
	jQuery('.remove-timer-btn').on('click', function() {
		hasTimer = false;
		jQuery('.timer').timer('remove');
		jQuery(this).addClass('hidden');
		jQuery('.start-timer-btn').removeClass('hidden');
		jQuery('.pause-timer-btn, .resume-timer-btn').addClass('hidden');
	});

	// Additional focus event for this demo
	jQuery('.timer').on('focus', function() {
		if(hasTimer) {
			jQuery('.pause-timer-btn').addClass('hidden');
			jQuery('.resume-timer-btn').removeClass('hidden');
		}
	});

	// Additional blur event for this demo
	jQuery('.timer').on('blur', function() {
		if(hasTimer) {
			jQuery('.pause-timer-btn').removeClass('hidden');
			jQuery('.resume-timer-btn').addClass('hidden');
		}
	});
	
	// AJAX Add Time from Timer
	
	jQuery('#add_time_ajax').live('click', function(e) {
	
		e.preventDefault();
		
		var task_id = jQuery('#task_time_task').val();
		
		var time = jQuery('#task_time_value').val();
		
		var spinner = jQuery('#add_time_loader');
		
		var data = {
		
			'action' : 'cqpim_add_timer_time',
			
			'task_id' : task_id,
			
			'time' : time
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

				jQuery('#add_time_ajax').prop('disabled', true);
				
				jQuery.colorbox.resize();

			},
			
		}).done(function(response){
					
			if(response.error == true) {
			
			spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#add_time_ajax').prop('disabled', false);
				
				jQuery('#time_messages').html(response.message);
				
				jQuery.colorbox.resize();

				
			} else {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#add_time_ajax').prop('disabled', false);
				
				jQuery('#time_messages').html(response.message);
				
				jQuery.colorbox.resize();
				
				location.reload();
				
			
			}				

		});
	
	});
	
	jQuery('#task_status_filter').live('change', function(e) {
	
		e.preventDefault();
		
		var filter = jQuery(this).val();
		
		var spinner = jQuery('#tasks_filter_spinner');
		
		var data = {
		
			'action' : 'cqpim_filter_tasks',
			
			'filter' : filter,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

			},
			
		}).done(function(response){
					
			if(response.error == true) {
			
				spinner.hide();
				
			} else {
			
				spinner.hide();
				
				location.reload();
				
			
			}				

		});
	
	});	
	
	jQuery('.calendar_filter').live('change', function(e) {
	
		e.preventDefault();
		
		var filters = jQuery('.calendar_filter:checkbox:checked').map(function() {
			return this.value;
		}).get();
		
		var spinner = jQuery('#ajax_spinner');
		
		var data = {
		
			'action' : 'cqpim_filter_calendar',
			
			'filters' : filters,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

			},
			
		}).done(function(response){
						
			location.reload();	

		});
	
	});	
	
});



