jQuery(document).ready(function() {

	jQuery('#dd-container').sortable({
	
		handle: '.dd-reorder',
		
		cancel: '',
		
		update: function( event, ui ) {
		
			var i = 0;
			
			jQuery('.dd-milestone').each(function(i) {
			
				jQuery(this).children('input.element_weight').val(i);
				
				i = i + 1;
			
			});
		
		}
	
	});
	
	jQuery('.dd-tasks').sortable({
	
		handle: '.dd-reorder',
		
		cancel: '',
		
		update: function( event, ui ) {
		
			var tasks = jQuery(this).find('.dd-task');
			
			var template_id = jQuery('#post_ID').val();
		
			var i = 0;
			
			weights = {};
			
			jQuery(tasks).each(function(i) {
			
				var ms_id = jQuery(this).children('input.ms_id').val();
					
				var task_id = jQuery(this).children('input.task_id').val();
			
				jQuery(this).children('input.task_weight').val(i);
				
				weights[task_id] = {
				
					'task_id' : task_id,
					
					'ms_id' : ms_id,
					
					'weight' : i,
				
				};
				
				i = i + 1;
			
			});
			
			//console.log(weights);
			
			var data = {

				'action' : 'cqpim_update_task_weight_template',
				
				'weights' : weights,
				
				'template_id' : template_id

			};		
								
			jQuery.ajax({
			
				url: ajaxurl,

				data: data,

				type: 'POST',

				dataType: 'json'

			}).always(function(response){
			
				console.log(response);
			
			});
			
		}
		
	});

	jQuery('.datepicker').datepicker({ 
	
		showButtonPanel: true,
		closeText: objectL10n.closeText,
		currentText: objectL10n.currentText,
		monthNames: objectL10n.monthNames,
		monthNamesShort: objectL10n.monthNamesShort,
		dayNames: objectL10n.dayNames,
		dayNamesShort: objectL10n.dayNamesShort,
		dayNamesMin: objectL10n.dayNamesMin,
		dateFormat: objectL10n.dateFormat,
		firstDay: objectL10n.firstDay,	
	
	});

	jQuery('button.cancel-colorbox').on('click', function(e){
	
		e.preventDefault();
		
		jQuery.colorbox.close();
	
	});

	jQuery('a#add-milestone').on('click', function(e){
	
		e.preventDefault();
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#add-milestone-div',
			
			'opacity': '0.5',
			
		});	
		
		jQuery.colorbox.resize();
	
	});
	
	jQuery('a#clear-all').on('click', function(e){
	
		e.preventDefault();
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#clear-all-div',
			
			'opacity': '0.5',
			
		});	
		
		jQuery.colorbox.resize();
	
	});
	
	jQuery('button.edit-milestone').on('click', function(e){
	
		e.preventDefault();
		
		var key = jQuery(this).val();
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#edit-milestone-' + key,
			
			'opacity': '0.5',
			
		});	
		
		jQuery.colorbox.resize();
	
	});
	
	jQuery('.add_task').on('click', function(e){
	
		e.preventDefault();
		
		var id = jQuery(this).data('ms');
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#add-task-div-' + id,
			
			'opacity': '0.5',
			
		});		
	
	});
	
	jQuery('button.edit-task').on('click', function(e){
	
		e.preventDefault();
		
		var ms = jQuery(this).attr('data-ms');
		
		var key = jQuery(this).val();
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#edit-task-div-' + ms + key,
			
			'opacity': '0.5',
			
		});	
	
	});
	
	jQuery('button.save').on('click', function(e){
	
		e.preventDefault();
		
		jQuery.colorbox.close();
		
		setTimeout(function(){
	
			jQuery('#publish').trigger('click');
		
		}, 500);
	
	});
	
	// Add Milestone

	jQuery('#add_quote_element').click(function(e) {
	
		e.preventDefault();
		
		var title = jQuery('#quote_element_title').val();
		
		var start = jQuery('#quote_element_start').val();
		
		var deadline = jQuery('#quote_element_finish').val();
		
		var cost = jQuery('#quote_element_cost').val();
		
		var milestone_id = jQuery('#add_milestone_id').val();
		
		var milestone_order = jQuery('#add_milestone_order').val();

		var post_id = jQuery('#post_ID').val();
		
		var domain = document.domain;
		
		var spinner = jQuery('.ajax_spinner');
		
		var data = {
		
			'action' : 'cqpim_add_step_to_template',
		
			'title' : title,
			
			'start' : start,
			
			'deadline' : deadline,
			
			'ID' : post_id,
			
			'cost' : cost,
			
			'milestone_id' : milestone_id
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#add_quote_element').prop('disabled', true);

			},

		}).done(function(response){
		
			if(response.error == true) {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#add_quote_element').prop('disabled', false);
			
				alert(response.errors);
				
			} else {

				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#add_quote_element').prop('disabled', false);
				
				location.reload();
			
			}

		});
	
	});
	
	// Delete Quote Stage
	
	// Confirm
	
	jQuery(document).on('click', 'button.delete_stage_conf', function(e){
	
		e.preventDefault();
		
		var id = jQuery(this).val();
		
			jQuery.colorbox({
			
				'inline': true,
				
				'fixed': true,
			
				'href': '#delete-milestone-div-' + id,	

				'opacity': '0.5',
					
			});			
	
	});
	
	// Cancel Delete
	
	jQuery(document).on('click', 'button.cancel_delete_stage', function(e){
	
		e.preventDefault();
		
		jQuery.colorbox.close();
	
	});
	
	//Delete
	
	jQuery(document).on('click', 'button.delete_stage', function(e){
	
		e.preventDefault();
		
		var element = jQuery(this);
		
		var idToRemove = jQuery(element).val();

		var hiddenfield = '<input type="hidden" name="delete_stage[]" value="' + idToRemove + '" data-id="' + idToRemove + '" >';		

		// set a hidden field that will remove the data from the database

		jQuery(hiddenfield).appendTo('#add-milestone');

		// remove the div containing all the data

		jQuery(this).parents('div.quote_element_add').css('display', 'none');
					
		jQuery('#publish').trigger('click');

	});
	
	jQuery('button.save-task').on('click', function(e){
	
		e.preventDefault();
		
		var id = jQuery(this).val();
		
		var title = jQuery(this).siblings('#task_title_' + id).val();
		
		var description = jQuery(this).siblings('#task_description_' + id).val();
		
		var start = jQuery(this).siblings('#task_start_' + id).val();
		
		var ms_id = jQuery(this).siblings('#task_milestone_id_' + id).val();
		
		var project_id = jQuery(this).siblings('#task_project_id_' + id).val();
		
		var deadline = jQuery(this).siblings('#task_finish_' + id).val();
		
		var template_id = jQuery('#post_ID').val();
		
		var domain = document.domain;
		
		var spinner = jQuery('.ajax_spinner');
		
		var data = {
		
			'action' : 'cqpim_create_task_template',
			
			'task_finish' : deadline,
			
			'task_project_id' : project_id,
			
			'task_title' : title,
			
			'task_milestone_id' : ms_id,
			
			'description' : description,
			
			'start' : start
		
		};
		
		if(title) {
		
			jQuery.ajax({

				url: ajaxurl,

				data: data,

				type: 'POST',

				dataType: 'json',

				beforeSend: function(){

					// show spinner

					spinner.show();

					// disable form elements while awaiting data

					jQuery('button.save-task').prop('disabled', true);

				},

			}).done(function(response){
			
				if(response.error == true) {
				
					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.save-task').prop('disabled', false);
				
					alert(response.errors);
					
				} else {

					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.save-task').prop('disabled', false);
					
					location.reload();
				
				}

			});		
		
		} else {
		
			jQuery('#task-messages-' + ms_id).html('<p style="color:#F00">Title is required</p>');
			
		}
	
	});
	
	// Update a Task
	
	jQuery('button.update-task').on('click', function(e){
	
		e.preventDefault();
		
		var task_id = jQuery(this).val();
		
		var ms = jQuery(this).attr('data-ms');
		
		var tid = jQuery('#post_ID').val();
		
		var title = jQuery('#task_title_' + ms + task_id).val();
		
		var deadline = jQuery('#task_finish_' + ms + task_id).val();
		
		var start = jQuery('#task_start_' + ms + task_id).val();
		
		var description = jQuery('#task_description_' + ms + task_id).val();
		
		var template_id = jQuery('#post_ID').val();
				
		var domain = document.domain;
		
		var spinner = jQuery('#ajax_spinner_edit_' + ms + task_id);
		
		var data = {
		
			'action' : 'cqpim_update_task_template',
			
			'ms' : ms,
			
			'tid' : tid,
			
			'task_id' : task_id,
			
			'title' : title,
			
			'deadline' : deadline,
			
			'start' : start,
			
			'description' : description
		
		};
		
			jQuery.ajax({

				url: ajaxurl,

				data: data,

				type: 'POST',

				dataType: 'json',

				beforeSend: function(){

					// show spinner

					spinner.show();

					// disable form elements while awaiting data

					jQuery('button.update-task').prop('disabled', true);

				},

			}).done(function(response){
			
				if(response.error == true) {
				
					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.update-task').prop('disabled', false);
				
					alert(response.errors);
					
				} else {

					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.update-task').prop('disabled', false);
					
					location.reload();
				
				}

			});			
	
	});
	
	jQuery('button.delete_task').on('click', function(e){
	
		e.preventDefault();
		
		var tid = jQuery(this).attr('data-tid');
		
		var ms = jQuery(this).attr('data-ms');
		
		var task_id = jQuery(this).val();
				
		var domain = document.domain;
		
		var spinner = jQuery('#ajax_spinner_' + ms + task_id);
		
		var data = {
		
			'action' : 'cqpim_delete_task_template',
			
			'task_id' : task_id,
			
			'tid' : tid,
			
			'ms' : ms
		
		};
		
			jQuery.ajax({

				url: ajaxurl,

				data: data,

				type: 'POST',

				dataType: 'json',

				beforeSend: function(){

					// show spinner

					spinner.show();

					// disable form elements while awaiting data

					jQuery('button.delete_task').prop('disabled', true);

				},

			}).done(function(response){
			
				if(response.error == true) {
				
					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.delete_task').prop('disabled', false);
				
					alert(response.errors);
					
				} else {

					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button.delete_task').prop('disabled', false);
					
					location.reload();
				
				}

			});		
	
	
	});
	
	jQuery('button#clear-all-action').on('click', function(e){
	
		e.preventDefault();
		
		var tid = jQuery(this).val();
				
		var domain = document.domain;
		
		var spinner = jQuery('.ajax_spinner');
		
		var data = {
		
			'action' : 'cqpim_clear_all_template',
			
			'tid' : tid,
		
		};
		
			jQuery.ajax({

				url: ajaxurl,

				data: data,

				type: 'POST',

				dataType: 'json',

				beforeSend: function(){

					// show spinner

					spinner.show();

					// disable form elements while awaiting data

					jQuery('button#clear-all-action').prop('disabled', true);

				},

			}).done(function(response){
			
				if(response.error == true) {
				
					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button#clear-all-action').prop('disabled', false);
				
					alert(response.errors);
					
				} else {

					spinner.hide();

					// re-enable form elements so that new enquiry can be posted

					jQuery('button#clear-all-action').prop('disabled', false);
					
					location.reload();
				
				}

			});		
	
	
	});
		
});
		
