<?php

// Contact Financials Metabox

function client_financials_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'client_financials_metabox', 

 	 	'client_financials_metabox_nonce' );
		
		$client_details = get_post_meta($post->ID, 'client_details', true);
		
		$invoice_terms = isset($client_details['invoice_terms']) ? $client_details['invoice_terms']: '';
		
		$tax_disabled = isset($client_details['tax_disabled']) ? $client_details['tax_disabled']: '';
		
		$system_invoice_terms = get_option('company_invoice_terms');
		
		$system_tax_name = get_option('sales_tax_name');
		
		$system_tax_rate = get_option('sales_tax_rate');
		
		?>
			<p><strong><?php _e('Settings', 'cqpim'); ?></strong></p>
			
			<?php if(!empty($system_tax_rate)) { ?>
			
				<input type="checkbox" name="tax_disabled" value="1" <?php if($tax_disabled == 1) { echo 'checked="checked"'; } ?>/> <?php printf(__('This client should NOT be charged %1$s.','cqpim'), $system_tax_name, $system_tax_rate); ?><br /><br />
		
			<?php } ?>
			
			<label for="invoice_terms"><?php _e('Invoice Terms:', 'cqpim'); ?> </label>
		
			<select id="invoice_terms" name="invoice_terms">
			
				<option value=""><?php printf(__('Use Company Terms (%1$s days)', 'cqpim'), $system_invoice_terms); ?> </option>
				
				<option value="1" <?php if($invoice_terms == 1) { echo 'selected'; } ?>><?php _e('Due on Receipt', 'cqpim'); ?></option>
				
				<option value="7" <?php if($invoice_terms == 7) { echo 'selected'; } ?>><?php _e('7 days', 'cqpim'); ?></option>
									
				<option value="14" <?php if($invoice_terms == 14) { echo 'selected'; } ?>><?php _e('14 days', 'cqpim'); ?></option>
									
				<option value="28" <?php if($invoice_terms == 28) { echo 'selected'; } ?>><?php _e('28 days', 'cqpim'); ?></option>
									
				<option value="30" <?php if($invoice_terms == 30) { echo 'selected'; } ?>><?php _e('30 days', 'cqpim'); ?></option>
									
				<option value="60" <?php if($invoice_terms == 60) { echo 'selected'; } ?>><?php _e('60 days', 'cqpim'); ?></option>
				
				<option value="90" <?php if($invoice_terms == 90) { echo 'selected'; } ?>><?php _e('90 days', 'cqpim'); ?></option>
			
			</select>
			
			<p><strong><?php _e('Recurring Invoices', 'cqpim'); ?></strong></p>
			
			<p><?php _e('Recurring Invoices can be automatically created and sent on specified intervals.', 'cqpim'); ?></p>
			
			<?php $recurring_invoices = get_post_meta($post->ID, 'recurring_invoices', true);
			
			if(empty($recurring_invoices)) {
			
				echo '<p>' . __('No recurring invoices found...', 'cqpim') . '</p>';
			
			} else {
			
				echo '<table class="milestones dataTable">';
					
				echo '<thead>';
					
				echo '<tr><th>' . __('Title', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th><th>' . __('Start', 'cqpim') . '</th><th>' . __('End', 'cqpim') . '</th><th>' . __('Frequency', 'cqpim') . '</th><th>' . __('Last Issue', 'cqpim') . '</th><th>' . __('Next Issue', 'cqpim') . '</th><th>' . __('Auto Send?', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th></tr>';
					
				echo '</thead>';

				echo '<tbody>';
			
				foreach($recurring_invoices as $key => $invoice) {
				
					$start = isset($invoice['start']) ? $invoice['start'] : '';
					
					if(is_numeric($start)) { $start = date(get_option('cqpim_date_format') . ' H:i', $start); } else { $start = $start; }
					
					if(empty($start)) {
					
						$start = __('N/A', 'cqpim');
					
					}

					if($invoice['auto'] == 1) {
					
						$auto = '<span class="task_complete">' . __('Yes', 'cqpim') . '</span>';
						
					} else {
					
						$auto = '<span class="task_pending">' . __('No', 'cqpim') . '</span>';
						
					}

					if($invoice['status'] == 1) {
					
						$status = '<span class="task_complete">' . __('Active', 'cqpim') . '</span>';
						
					} else {
					
						$status = '<span class="task_over">' . __('Disabled', 'cqpim') . '</span>';
						
					} 
					
					if(empty($invoice['end'])) {
					
						$end = 'Ongoing';
						
					} else {

						$end = $invoice['end'];
						
					} 
					
					if(is_numeric($end)) { $end = date(get_option('cqpim_date_format') . ' H:i', $end); } else { $end = $end; }
					
					if($invoice['next_run'] != '<span class="task_over">' . __('Finished', 'cqpim') . '</div>') {
					
						$next = date(get_option('cqpim_date_format') . ' H:i', $invoice['next_run']);
						
					} else {
					
						$next = '<span class="task_over">' . __('Finished', 'cqpim') . '</div>';
						
					} ?>
				
					<tr>
					
						<td><?php echo $invoice['title']; ?></td>
						
						<td><?php echo $status; ?></td>
						
						<td><?php echo $start; ?></td>
						
						<td><?php echo $end; ?></td>
						
						<td><?php echo ucfirst(isset($invoice['frequency']) ? $invoice['frequency'] : ''); ?></td>
						
						<td><?php echo isset($invoice['last_run']) ? date(get_option('cqpim_date_format'), $invoice['last_run']) : 'N/A'; ?></td>
						
						<td><?php echo $next; ?></td>
						
						<td><?php echo $auto; ?></td>
						
						<td><?php if($invoice['status'] == 1) { ?><button class="edit-task" value="<?php echo $key; ?>"><img title="Edit Recurring Invoice" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <?php } ?><button class="delete_task" value="<?php echo $key; ?>"><img title="Delete Recurring Invoice" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <div id="ajax_spinner_<?php echo $key; ?>" class="ajax_spinner" style="display:none"></div></td>
					
					</tr>
				
				<?php }
				
				echo '</tbody>';
				
				echo '</table>';
			
			}
			
			if(empty($recurring_invoices)) {
			
				$recurring_invoices = array();
				
			}
			
			foreach($recurring_invoices as $key => $invoice) { 
			
			$start = isset($invoice['start']) ? $invoice['start'] : '';
			
			if(is_numeric($start)) { $start = date(get_option('cqpim_date_format'), $start); } else { $start = $start; }
			
			$end = isset($invoice['end']) ? $invoice['end'] : ''; 
			
			if(is_numeric($end)) { $end = date(get_option('cqpim_date_format'), $end); } else { $end = $end; }?>
			
			<div style="display:none" id="edit-recurring-invoice-container-<?php echo $key; ?>">
			
				<div id="edit-recurring-invoice-<?php echo $key; ?>" class="edit-rec-inv" style="width:600px">
				
					<div style="padding:12px">
					
						<h3><?php printf(__('Edit %1$s', 'cqpim'), $invoice['title']); ?></h3>
						
						<p><strong><?php _e('Title', 'cqpim'); ?></strong></p>
						
						<input type="text" id="rec-inv-title-<?php echo $key; ?>" value="<?php echo isset($invoice['title']) ? $invoice['title'] : ''; ?>" />
						
						<p><strong><?php _e('Contact', 'cqpim'); ?></strong></p>
						
						<select id="client_contact_select_<?php echo $key; ?>">
						
							<option value="">Choose a contact...</option>
							
							<?php 
							
							$client_details = get_post_meta($post->ID, 'client_details', true);
							
							if($client_details['user_id'] == $invoice['contact']) {
							
								$selected = 'selected="selected"';
								
							} else {
							
								$selected = '';
								
							}
							
							echo '<option value="' . $client_details['user_id'] . '" ' . $selected . '>' . $client_details['client_contact'] . ' ' . __('(Main contact)', 'cqpim') . '</option>';
							
							$selected = '';
							
							$contacts = get_post_meta($post->ID, 'client_contacts', true);
							
							foreach($contacts as $contact) {
							
								if($contact['user_id'] == $invoice['contact']) {
								
									$selected = 'selected="selected"';
									
								} else {
								
									$selected = '';
									
								}								
							
								echo '<option value="' . $contact['user_id'] . '" ' . $selected . '>' . $contact['name'] . '</option>';
							
							}
							
							?>
						
						</select>
						
						<p><strong><?php _e('Start/End', 'cqpim'); ?></strong></p>
						
						<p><?php _e('You can specify a Start/End date for this invoice. If you leave the start blank then the invoice will start sending today. If you leave End blank, then the invoice will send according to the frequency until you delete or disable it.', 'cqpim'); ?></p>
						
						<input style="width:48%; margin-right:2%" type="text" class="datepicker" id="rec-inv-start-<?php echo $key; ?>" value="<?php echo $start; ?>" placeholder="Start" />
						
						<input style="width:48%;" type="text" class="datepicker" id="rec-inv-end-<?php echo $key; ?>" value="<?php echo $end; ?>" placeholder="End" />

						<div style="float:left; width:51%">
						
							<p><strong><?php _e('Frequency', 'cqpim'); ?></strong></p>
							
							<select id="rec-inv-frequency-<?php echo $key; ?>">
							
								<option value=""><?php _e('Choose a frequency', 'cqpim'); ?></option>
								
								<option value="daily" <?php if($invoice['frequency'] == 'daily') { echo 'selected="selected"'; } ?>><?php _e('Daily', 'cqpim'); ?></option>
								
								<option value="weekly" <?php if($invoice['frequency'] == 'weekly') { echo 'selected="selected"'; } ?>><?php _e('Weekly', 'cqpim'); ?></option>
								
								<option value="biweekly" <?php if($invoice['frequency'] == 'biweekly') { echo 'selected="selected"'; } ?>><?php _e('Fortnightly', 'cqpim'); ?></option>
								
								<option value="monthly" <?php if($invoice['frequency'] == 'monthly') { echo 'selected="selected"'; } ?>><?php _e('Monthly', 'cqpim'); ?></option>
								
								<option value="bimonthly" <?php if($invoice['frequency'] == 'bimonthly') { echo 'selected="selected"'; } ?>><?php _e('Bi Monthly', 'cqpim'); ?></option>
								
								<option value="threemonthly" <?php if($invoice['frequency'] == 'threemonthly') { echo 'selected="selected"'; } ?>><?php _e('Every Three Months', 'cqpim'); ?></option>
								
								<option value="sixmonthly" <?php if($invoice['frequency'] == 'sixmonthly') { echo 'selected="selected"'; } ?>><?php _e('Every Six Months', 'cqpim'); ?></option>
								
								<option value="yearly" <?php if($invoice['frequency'] == 'yearly') { echo 'selected="selected"'; } ?>><?php _e('Yearly', 'cqpim'); ?></option>
								
								<option value="biyearly" <?php if($invoice['frequency'] == 'biyearly') { echo 'selected="selected"'; } ?>><?php _e('Biyearly', 'cqpim'); ?></option>
							
							</select>
						
						</div>
						
						<div style="float:left; width:48%">
						
							<p><strong><?php _e('Status', 'cqpim'); ?></strong></p>
							
							<select id="rec-inv-status-<?php echo $key; ?>">
							
								<option value="1" <?php if($invoice['status'] == 1) { echo 'selected="selected"'; } ?>><?php _e('Active', 'cqpim'); ?></option>
								
								<option value="0" <?php if($invoice['status'] == 0) { echo 'selected="selected"'; } ?>><?php _e('Disabled', 'cqpim'); ?></option>
							
							</select>
						
						</div>
						
						<div class="clear"></div>
						
						<p><strong><?php _e('Send Automatically', 'cqpim'); ?></strong></p>
						
						<input type="checkbox" id="rec-inv-auto-<?php echo $key; ?>" <?php if($invoice['auto'] == 1) { echo 'checked="checked"'; } ?> /> <?php _e('Send the recurring invoices to the client on creation.', 'cqpim'); ?>
						
						<p><strong><?php _e('Invoice Items', 'cqpim'); ?></strong></p>
						
						<div class="repeater">	
						
							<?php if(!empty($invoice['items'])) { ?>
						
							<div data-repeater-list="group-a">
							
								<?php foreach($invoice['items'] as $item) { ?>
										
									<div class="line_item" data-repeater-item>
										
										<table style="table-layout: fixed" class="milestones invoice-items">
											
											<tbody>
											
												<tr>
							  
													<td style="width:10%"><input data-row="0" data-key="<?php echo $key; ?>" id="edit_<?php echo $key; ?>_invoice_qty" class="edit_<?php echo $key; ?>_invoice_qty" type="text" name="qty" value="<?php echo $item['qty']; ?>" placeholder="<?php _e('Qty', 'cqpim'); ?>" /></td>
									
													<td style="width:50%"><input data-row="0" data-key="<?php echo $key; ?>" id="edit_<?php echo $key; ?>_invoice_desc" class="edit_<?php echo $key; ?>_invoice_desc" type="text" name="desc" value="<?php echo $item['desc']; ?>" placeholder="<?php _e('Description', 'cqpim'); ?>" /></td>
									
													<td style="width:15%"><input data-row="0" data-key="<?php echo $key; ?>" id="edit_<?php echo $key; ?>_invoice_price" class="edit_<?php echo $key; ?>_invoice_price" type="text" name="price" value="<?php echo $item['price']; ?>" placeholder="<?php _e('Price', 'cqpim'); ?>" /></td>
										
													<td style="width:10%"><input data-row="0" data-key="<?php echo $key; ?>" class="line_delete" data-repeater-delete type="button" value=""/></td>
									
												</tr>
											
											</tbody>
											
										</table>
										
									</div>

								<?php } ?>
							  
							</div>
							
							<?php } else { ?>
							
							<div data-repeater-list="group-a">
									
								<div class="line_item" data-repeater-item>
									
									<table style="table-layout: fixed" class="milestones invoice-items">
										
										<tbody>
										
											<tr>
						  
												<td style="width:10%"><input data-row="0" id="invoice_qty" class="invoice_qty" type="text" name="qty" value="" placeholder="<?php _e('Qty', 'cqpim'); ?>" /></td>
								
												<td style="width:50%"><input data-row="0" id="invoice_desc" class="invoice_desc" type="text" name="desc" value="" placeholder="<?php _e('Description', 'cqpim'); ?>" /></td>
								
												<td style="width:15%"><input data-row="0" id="invoice_price" class="invoice_price" type="text" name="price" value="" placeholder="<?php _e('Price', 'cqpim'); ?>" /></td>
									
												<td style="width:10%"><input data-row="0" class="line_delete" data-repeater-delete type="button" value=""/></td>
								
											</tr>
										
										</tbody>
										
									</table>
									
								</div>				
							  
							</div>							
							
							<?php } ?>
							
							<input class="add_line_item_row" data-repeater-create type="button" value=""/>
							
						</div>
						
						<br />
						
						<div class="edit-inv-messages"></div>
						
						<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
									
						<button class="edit-rec-inv-btn metabox-add-button" value="<?php echo $post->ID; ?>" data-key="<?php echo $key; ?>"><?php _e('Edit', 'cqpim'); ?><span id="edit-rec-inv-spinner-<?php echo $key; ?>" class="ajax_loader" style="display:none"></span></button>

						<div class="clear"></div>

					</div>
					
				</div>
				
			</div>
			
			<?php }
			
			?>
			
			
			
			<button class="metabox-add-button" id="create-rec-inv"><?php _e('Add Recurring Invoice', 'cqpim'); ?></button>
			
			<div class="clear"></div>
			
			<div style="display:none" id="add-recurring-invoice-container">
			
				<div id="add-recurring-invoice" style="width:830px">
				
					<div style="padding:12px">
					
						<h3><?php _e('Add Recurring Invoice', 'cqpim'); ?></h3>
						
						<div style="width:800px">
						
							<div style="float:left; width:390px">
						
							<p><strong><?php _e('Title', 'cqpim'); ?></strong></p>
							
							<input type="text" id="rec-inv-title" value="" />
							
							<p><strong><?php _e('Contact', 'cqpim'); ?></strong></p>
							
							<select id="client_contact_select">
								
								<?php 
								
								$client_details = get_post_meta($post->ID, 'client_details', true);
								
								echo '<option value="' . $client_details['user_id'] . '">' . $client_details['client_contact'] . ' ' . __('(Main contact)', 'cqpim') . '</option>';
								
								$contacts = get_post_meta($post->ID, 'client_contacts', true);
								
								foreach($contacts as $contact) {
								
									echo '<option value="' . $contact['user_id'] . '">' . $contact['name'] . '</option>';
								
								}
								
								?>
							
							</select>
							
							<p><strong><?php _e('Start/End', 'cqpim'); ?></strong></p>
							
							<p><?php _e('You can specify a Start/End date for this invoice. If you leave the start blank then the invoice will start sending today. If you leave End blank, then the invoice will send according to the frequency until you delete or disable it.', 'cqpim'); ?></p>
							
							<input style="width:48%; margin-right:2%" type="text" class="datepicker" id="rec-inv-start" placeholder="<?php _e('Start', 'cqpim'); ?>" />
							
							<input style="width:48%;" type="text" class="datepicker" id="rec-inv-end" placeholder="<?php _e('End', 'cqpim'); ?>" />
							
							<div style="float:left; width:51%">
							
								<p><strong><?php _e('Frequency', 'cqpim'); ?></strong></p>
								
								<select id="rec-inv-frequency">
								
									<option value=""><?php _e('Choose a frequency', 'cqpim'); ?></option>
									
									<option value="daily"><?php _e('Daily', 'cqpim'); ?></option>
									
									<option value="weekly"><?php _e('Weekly', 'cqpim'); ?></option>
									
									<option value="biweekly"><?php _e('Fortnightly', 'cqpim'); ?></option>
									
									<option value="monthly"><?php _e('Monthly', 'cqpim'); ?></option>
									
									<option value="bimonthly"><?php _e('Bi Monthly', 'cqpim'); ?></option>
									
									<option value="threemonthly"><?php _e('Every Three Months', 'cqpim'); ?></option>
									
									<option value="sixmonthly"><?php _e('Every Six Months', 'cqpim'); ?></option>
									
									<option value="yearly"><?php _e('Yearly', 'cqpim'); ?></option>
								
								</select>
							
							</div>
							
							<div style="float:left; width:48%">
							
								<p><strong><?php _e('Status', 'cqpim'); ?></strong></p>
								
								<select id="rec-inv-status">
								
									<option value="1"><?php _e('Active', 'cqpim'); ?></option>
									
									<option value="0"><?php _e('Disabled', 'cqpim'); ?></option>
								
								</select>
							
							</div>
							
							<div class="clear"></div>
							
							<p><strong><?php _e('Send Automatically', 'cqpim'); ?></strong></p>
							
							<input type="checkbox" id="rec-inv-auto" /> <?php _e('Send the recurring invoices to the client on creation.', 'cqpim'); ?>
							
							</div>
							
							<div style="float:right; width:390px">
							
							<p><strong><?php _e('Invoice Items', 'cqpim'); ?></strong></p>
							
							<div class="repeater">	
							
								<div data-repeater-list="group-a">
										
									<div class="line_item" data-repeater-item>
										
										<table style="table-layout: fixed" class="milestones invoice-items">
											
											<tbody>
											
												<tr>
							  
													<td style="width:10%"><input data-row="0" id="invoice_qty" class="invoice_qty" type="text" name="qty" value="" placeholder="<?php _e('Qty', 'cqpim'); ?>" /></td>
									
													<td style="width:50%"><input data-row="0" id="invoice_desc" class="invoice_desc" type="text" name="desc" value="" placeholder="<?php _e('Description', 'cqpim'); ?>" /></td>
									
													<td style="width:15%"><input data-row="0" id="invoice_price" class="invoice_price" type="text" name="price" value="" placeholder="<?php _e('Price', 'cqpim'); ?>" /></td>
										
													<td style="width:10%"><input data-row="0" class="line_delete" data-repeater-delete type="button" value=""/></td>
									
												</tr>
											
											</tbody>
											
										</table>
										
									</div>				
								  
								</div>
								
								<input class="add_line_item_row" data-repeater-create type="button" value=""/>
								
							</div>
							
							<br />
							
							<div class="rec-inv-messages"></div>
							
							<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
										
							<button id="add_rec_inv" class="metabox-add-button" value="<?php echo $post->ID; ?>"><?php _e('Add Recurring Invoice', 'cqpim'); ?> <span id="rec-inv-spinner" class="ajax_loader" style="display:none"></span></button>

							</div>
							
							<div class="clear"></div>
							
						</div>
					
					</div>
				
				</div>
				
			</div>
			
			<p><strong><?php _e('Past Invoices', 'cqpim'); ?></strong></p>
			
		
		<?php
		
		$args = array(
		
			'post_type' => 'cqpim_invoice',
			
			'posts_per_page' => -1,
			
			'post_status' => 'publish',
			
			'meta_key' => 'invoice_client',
			
			'meta_value' => $post->ID
			
		);
		
		$invoices = get_posts($args);
	
		if($invoices) {
		
			echo '<table class="milestones dataTable-CI">';
				
			echo '<thead>';
				
			echo '<tr><th>' . __('Invoice ID', 'cqpim') . '</th><th>' . __('Project Ref', 'cqpim') . '</th><th>' . __('Invoice Date', 'cqpim') . '</th><th>' . __('Due Date', 'cqpim') . '</th><th>' . __('Amount', 'cqpim') . '</th><th>' . __('Outstanding', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
				
			echo '</thead>';
		
			foreach($invoices as $invoice) {
				
					$currency = get_option('currency_symbol');
				
					$invoice_link = get_edit_post_link($invoice->ID);
					
					$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
					
					$invoice_payments = get_post_meta($invoice->ID, 'invoice_payments', true);
					
					$total_paid = 0;
					
					if(empty($invoice_payments)) {
					
						$invoice_payments = array();
						
					}
					
					foreach($invoice_payments as $payment) {
						
						$amount = isset($payment['amount']) ? $payment['amount'] : 0;
							
						$total_paid = $total_paid + $amount;
						
					}
					
					$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
					
					$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
					
					$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
					
					if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; }
					
					$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
					
					$subtotal = isset($invoice_totals['sub']) ? $invoice_totals['sub'] : '';
					
					$tax_rate = get_option('sales_tax_rate');
					
					if(!empty($tax_rate)) {
					
						$total = $total;
					
					} else {
					
						$total = $subtotal;
						
					}
					
					$project_id = isset($invoice_details['project_id']) ? $invoice_details['project_id'] : '';
					
					$project_details = get_post_meta($project_id, 'project_details', true);
					
					$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
					
					$project_link = get_edit_post_link($project_id);
					
					$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
					
					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					
					if(empty($on_receipt)) {
					
						$due_string = date(get_option('cqpim_date_format'), $due);
						
					} else {
					
						$due_string = __('Due on Receipt', 'cqpim');
						
					}
					
					$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
					
					$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
					
					$now = time();
					
					if(!$paid) {
				
						if($due) {
					
							if($now > $due) {
							
								if(empty($on_receipt)) {
								
									$class = 'overdue';
								
									$status = '<span class="task_over"><strong>' . __('OVERDUE', 'cqpim') . '</strong></span>';
									
								} else {
								
									$class = 'overdue';
									
									$status = '<span class="task_over"><strong>' . __('DUE ON RECEIPT', 'cqpim') . '</strong></span>';
								
								}		
						
							} else {
							
								if($sent) {
								
									$class = 'sent';
						
									$status = '<span class="task_pending">' . __('Sent', 'cqpim') . '</span>';							
								
								} else {
								
									$class = 'not-sent';
						
									$status = '<span class="task_over">' . __('Not Sent', 'cqpim') . '</span>';							
								
								}
							
							}
					
						}
				
					} else {
					
						$class = 'paid';
					
						$status = '<span class="task_complete">' . __('Paid', 'cqpim') . '</span>';
						
					}
					
					$outstanding = $total - $total_paid;
								
					echo '<tr>';
					
					echo '<td><a href="' . $invoice_link . '" target="_blank">' . $invoice_id . '</a></td>';
					
					if($project_ref) {
					
						echo '<td><a href="' . $project_link . '" target="_blank">' . $project_ref . '</a></td>';
					
					} else {
					
						echo '<td>' . __('N/A', 'cqpim') . '</td>';
					
					}
					
					echo '<td>' . $invoice_date . '</td>';
					
					echo '<td>' . $due_string . '</td>';
					
					echo '<td>' . $currency . '' . $total . '</td>';
					
					echo '<td>' . $currency . '' . $outstanding . '</td>';
					
					echo '<td class="' . $class . '">' . $status . '</td>';
					
					echo '</tr>';				
			
			}
			
			echo '</table>';
			
		} else {
		
			echo '<p>' . __('This client does not have any invoices assigned...', 'cqpim') . '</p>';
			
		}		
		
}

// Save Client Financials Fields

add_action( 'save_post', 'save_client_financials_metabox_data' );

function save_client_financials_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['client_financials_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['client_financials_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'client_financials_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	if(isset($_POST['invoice_terms'])) {
	
		$client_details = get_post_meta($post_id, 'client_details', true);
	
		$invoice_terms = $_POST['invoice_terms'];
		
		$client_details['invoice_terms'] = $invoice_terms;
		
		update_post_meta($post_id, 'client_details', $client_details);
	
	}
	
	if(isset($_POST['tax_disabled'])) {
	
		$client_details = get_post_meta($post_id, 'client_details', true);
	
		$tax_disabled = $_POST['tax_disabled'];
		
		$client_details['tax_disabled'] = $tax_disabled;
		
		update_post_meta($post_id, 'client_details', $client_details);	
	
	} else {
	
		$client_details = get_post_meta($post_id, 'client_details', true);
		
		$client_details['tax_disabled'] = 0;
		
		update_post_meta($post_id, 'client_details', $client_details);
	
	}
	
	
}