<?php

	add_action( 'add_meta_boxes', 'add_contact_cpt_metaboxes' );

	function add_contact_cpt_metaboxes(){

		add_meta_box( 

			'contact_details', 

			__('Client Details', 'cqpim'),

			'contact_details_metabox_callback', 

			'cqpim_client', 

			'side',
			
			'high'

		);
		
		add_meta_box( 

			'client_notes', 

			__('Client Notes', 'cqpim'),

			'client_notes_metabox_callback', 

			'cqpim_client', 

			'normal'

		);
		
		add_meta_box( 

			'client_team', 

			__('Client Contacts', 'cqpim'),

			'client_team_metabox_callback', 

			'cqpim_client', 

			'normal'

		);
		
		if(current_user_can('edit_cqpim_invoices')) {
		
		if(get_option('disable_invoices') != 1) {
		
			add_meta_box( 

				'client_financials', 

				__('Client Financials', 'cqpim'), 

				'client_financials_metabox_callback', 

				'cqpim_client', 

				'normal'

			);
			
			}
		
		}
		
		if(current_user_can('edit_cqpim_supports')) {
		
			add_meta_box( 

				'client_tickets', 

				__('Client Tickets', 'cqpim'), 

				'client_tickets_metabox_callback', 

				'cqpim_client', 

				'normal'

			);
		
		}
		
		if(!current_user_can('publish_cqpim_clients')) {
		
			remove_meta_box( 'submitdiv', 'cqpim_client', 'side' );
			
		}

	}
	
	require_once( 'contact_details.php' );
	
	require_once( 'financials.php' );
	
	require_once( 'notes.php' );
	
	require_once( 'teams.php' );
	
	require_once( 'tickets.php' );

	// Delete client user when client is deleted

	add_action( 'before_delete_post', 'cqpim_delete_client_user' );

	function cqpim_delete_client_user( $post_id ){
		
		global $post_type;   
		
		if ( $post_type != 'cqpim_client' ) return;
		
		require_once(ABSPATH.'wp-admin/includes/user.php' );
		
		$client_details = get_post_meta($post_id, 'client_details', true);
		
		$client_contacts = get_post_meta($post_id, 'client_contacts', true);
		
		$wp_user_id = $client_details['user_id'];
		
		wp_delete_user($wp_user_id);
		
		foreach($client_contacts as $key => $contact) {
		
			wp_delete_user($key);
		
		}
		
	}

