<?php



function invoice_payments_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'invoice_payments_metabox', 

 	 	'invoice_payments_metabox_nonce' ); 
		
		$invoice_payments = get_post_meta($post->ID, 'invoice_payments', true);
		
		if(!empty($invoice_payments)) {
		
			echo '<table class="milestones">';
			
			echo '<thead>';
			
			echo '<tr><th>' . __('Payment Date', 'cqpim') . '</th><th>' . __('Payment Amount', 'cqpim') . '</th><th>' . __('By', 'cqpim') . '</th><th>' . __('Notes', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th></tr>';
			
			echo '</thead>';
			
			echo '<tbody>';
			
			foreach($invoice_payments as $key => $payment) {
			
				$notes = isset($payment['notes']) ? $payment['notes'] : '';
			
				echo '<tr>';
				
				echo '<td>' . date(get_option('cqpim_date_format'), $payment['date']) . '</td>';
				
				echo '<td>' . get_option('currency_symbol') . $payment['amount'] . '</td>';
				
				echo '<td>' . $payment['by'] . '</td>';
				
				echo '<td>' . $notes . '</td>';
				
				echo '<td>'; ?> 
				
					<button class="edit-milestone" value="<?php echo $key; ?>"><img title="Edit Payment" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <button class="delete_stage_conf" data-id="<?php echo $key; ?>" value="<?php echo $key; ?>"><img title="Delete Payment" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <div id="payment_spinner_<?php echo $key; ?>" style="display:none" class="ajax_spinner"></div>		
				
				<?php echo '</td>';
				
				echo '</tr>';
			
			}
			
			echo '</tbody>';
			
			echo '</table>';		
		
		} else {
		
			_e('No payments made on this invoice', 'cqpim');
			
		}
		
		if(!empty($invoice_payments)) {
		
			foreach($invoice_payments as $key => $payment) {
			
			?>
			
				<div id="invoice_payment_container_<?php echo $key; ?>" style="display:none">
				
					<div id="invoice_payment_<?php echo $key; ?>" class="invoice_payment_edit">
					
						<div style="padding:12px">
						
							<h3><?php _e('Edit Payment', 'cqpim'); ?></h3>
							
							<p><?php _e('Payment Amount:', 'cqpim'); ?></p>
							
							<input style="width:270px" type="text" id="payment_amount_<?php echo $key; ?>" value="<?php echo get_option('currency_symbol'); ?><?php echo $payment['amount']; ?>" />
							
							<p><?php _e('Payment Notes:', 'cqpim'); ?></p>
							
							<textarea style="width:400px; height:150px" id="payment_notes_<?php echo $key; ?>"><?php echo isset($payment['notes']) ? $payment['notes'] : ''; ?></textarea>
							
							<div class="clear"></div>
							
							<?php echo '<button class="metabox-add-button" id="edit_paid" data-key="' . $key . '" data-id="' . $post->ID . '">' . __('Save Payment', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>'; ?>								
						
							<div class="ajax_spinner" id="spinner_<?php echo $key; ?>" style="display:none"></div>
						
						</div>
						
					</div>
					
				</div>		
			
			<?php
			
			}
		
		}
		
}