<?php


// Project Elements Metabox

function project_elements_metabox_callback( $post ) {


	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'project_elements_metabox', 

 	 	'project_elements_metabox_nonce' );
		
		$quote_elements = get_post_meta($post->ID, 'project_elements', true);
		
		//print_r($quote_elements);
		
		$quote_details = get_post_meta($post->ID, 'project_details', true);
		
		$type = isset($quote_details['quote_type']) ? $quote_details['quote_type'] : ''; 
		
		if(1) {
		
			if(empty($quote_elements)) {
			
				echo '<p>' . __('You have not added any milestones to this quote / estimate, please do so below', 'cqpim') . '</p>';
				
				$i = 0;
				
			} else {
			
				$i = 0;
				
				$currency = get_option('currency_symbol');
				
				if($type == 'estimate') { 
				
					$cost_title = __('Estimated Cost', 'cqpim');
					
				} else {
				
					$cost_title = __('Cost', 'cqpim');
					
				}
				
				//echo '<pre>';
				
				//print_r($quote_elements);
				
				//echo '</pre>';
				
				$ordered = array();
				
				$i = 0;
				
				$mi = 0;
				
				foreach($quote_elements as $key => $element) {
				
					$weight = isset($element['weight']) ? $element['weight'] : $mi;
				
					$ordered[$weight] = $element;
					
					$mi++;
				
				}
				
				ksort($ordered);
				
				// New Elements
				
				echo '<div id="dd-container">';
				
				foreach($ordered as $key => $element) {
				
					$eweight = isset($element['weight']) ? $element['weight'] : '';
				
					$cost = preg_replace("/[^\\d.]+/","", $element['cost']); 
				
					$task_status = isset($element['status']) ? $element['status'] : '';
					
					$task_deadline = isset($element['deadline']) ? $element['deadline'] : '';
					
					if(!is_numeric($task_deadline)) {
					
						$str_deadline = str_replace('/','-', $task_deadline);
					
						$deadline_stamp = strtotime($str_deadline);
					
					} else {
					
						$deadline_stamp = $task_deadline;
						
					}
					
					$now = time();
					
					if($task_status != 'complete') {
					
						if(!empty($deadline_stamp) && $now > $deadline_stamp) {
						
							$milestone_status_string = '<span class="task_over">' . __('Overdue', 'cqpim') . '</span>';
						
						} else {
						
							$milestone_status_string = isset($element['status']) ? $element['status'] : '';
							
							if(!$milestone_status_string || $milestone_status_string == 'pending') {
							
								$milestone_status_string = '<span class="task_pending">' . __('Pending', 'cqpim') . '</span>';
								
							} else if($milestone_status_string == 'on_hold') {
							
								$milestone_status_string = '<span class="task_over">' . __('On Hold', 'cqpim') . '</span>';
							
							}
						
						}
					
					} else {
					
						$milestone_status_string = '<span class="task_complete">' . __('Complete', 'cqpim') . '</span>';
					
					} ?>	
					
					<div class="dd-milestone">
					
						<input type="hidden" class="element_weight" name="element_weight[<?php echo $element['id']; ?>]" id="element_weight[<?php echo $element['id']; ?>]" value="<?php if(!empty($eweight)) { echo $eweight; } else { echo $i; } ?>" />
					
						<div class="dd-milestone-title">
						
							<span class="table-milestone" style="display:block; float:left; margin-right:10px;"><?php _e('Milestone', 'cqpim'); ?></span> <span style="display:block; float:left; max-width:240px; padding-top:3px;"><strong><?php echo $element['title']; ?></strong></span>
							
							<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
							
								<div class="dd-milestone-actions">
								
									<button class="edit-milestone" value="<?php echo $element['id']; ?>"><img title="Edit Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <button class="delete_stage_conf" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"><img title="Delete Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <button class="add_task" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $element['id']; ?>"><img title="Add Task to Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/new.png'; ?>" /></button> <button class="dd-reorder" value="<?php echo $element['id']; ?>"><img title="Reorder Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/reorder.png'; ?>" /></button>
							
								</div>
							
							<?php } ?>
							
							<div class="dd-milestone-item-half" style="width:80px; padding-top:2px">
							
								<?php echo $milestone_status_string; ?>
							
							</div>
							
							<div class="dd-milestone-item-half">
							
								<?php echo $currency; ?><?php echo $element['cost']; ?>
							
							</div>
							
							<div class="dd-milestone-item-double" style="width:200px">
							
								<?php if(!empty($element['start'])) { ?>
								
									<?php echo date(get_option('cqpim_date_format'), $element['start']) . ' -'; ?>
								
								<?php } ?>
					
								<?php if(!empty($element['deadline'])) { ?>
								
									<?php echo date(get_option('cqpim_date_format'), $element['deadline']); ?>
								
								<?php } ?>								
							
							</div>
							
							<div class="clear"></div>
						
						</div>
						
						<div class="dd-tasks" data-ms="<?php echo $element['id']; ?>">
						
							<?php 
							
							$args = array(
							
								'post_type' => 'cqpim_tasks',
								
								'posts_per_page' => -1,
								
								'meta_key' => 'milestone_id',
								
								'meta_value' => $element['id'],
								
								'orderby' => 'date',
								
								'order' => 'ASC'
								
							);
							
							$tasks = get_posts($args);
							
							$ti = 0;
							
							$ordered = array();
							
							$wi = 0;
							
							foreach($tasks as $task) {
							
								$task_details = get_post_meta($task->ID, 'task_details', true);
								
								$weight = isset($task_details['weight']) ? $task_details['weight'] : $wi;
								
								$ordered[$weight] = $task;
								
								$wi++;
							
							}
							
							ksort($ordered);
							
							foreach($ordered as $task) {
							
								$task_details = get_post_meta($task->ID, 'task_details', true);
								
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								
								$start = isset($task_details['task_start']) ? $task_details['task_start'] : '';
								
								$description = isset($task_details['task_description']) ? $task_details['task_description'] : '';
								
								$weight = isset($task_details['weight']) ? $task_details['weight'] : '';
								
								$task_owner = get_post_meta($task->ID, 'owner', true);
								
								if($task_owner) {
								
									$team_details = get_post_meta($task_owner, 'team_details', true);
									
									$team_name = isset($team_details['team_name']) ? $team_details['team_name']: '';
									
									if(!empty($team_name)) {
									
										$task_owner = ' (' . $team_name . ')';
									
									}
									
								} else {
								
									$task_owner = '';
									
									}
								
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								
								$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
								
								$task_status = isset($task_details['status']) ? $task_details['status'] : '';
								
								$task_time = isset($task_details['task_time']) ? $task_details['task_time'] : '';
								
								$task_priority = isset($task_details['task_priority']) ? $task_details['task_priority'] : '';
								
								if(!is_numeric($task_deadline)) {
								
									$str_deadline = str_replace('/','-', $task_deadline);
								
									$deadline_stamp = strtotime($str_deadline);
								
								} else {
								
									$deadline_stamp = $task_deadline;
									
								}
								
								$now = time();
								
								if($task_status != 'complete') {
								
									if(!empty($deadline_stamp) && $now > $deadline_stamp) {
									
										$task_status_string = '<span class="task_over">' . __('OVERDUE', 'cqpim') . '</span>';
									
									} else {
									
										$task_status_string = isset($task_details['status']) ? $task_details['status'] : '';
										
										if(!$task_status_string || $task_status_string == 'pending') {
										
											$task_status_string = '<span class="task_pending">' . __('Pending', 'cqpim') . '</span>';
											
										} else if($task_status_string == 'on_hold') {
										
											$task_status_string = '<span class="task_over">' . __('On Hold', 'cqpim') . '</span>';
										
										} else if($task_status_string == 'progress') {
										
											$task_status_string = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
										
										}
									
									}
								
								} else {
								
									$task_status_string = '<span class="task_complete">' . __('Complete', 'cqpim') . '</span>';
								
								}
								
								if($task_priority == 'low') {
								
									$priority_string = '<span class="task_complete">' . __('Low', 'cqpim') . '</span>';
								
								} elseif($task_priority == 'normal') {
								
									$priority_string = '<span class="task_complete">' . __('Normal', 'cqpim') . '</span>';
								
								} elseif($task_priority == 'high') {
								
									$priority_string = '<span class="task_pending">' . __('High', 'cqpim') . '</span>';
								
								} elseif($task_priority == 'immediate') {
								
									$priority_string = '<span class="task_over">' . __('Immediate', 'cqpim') . '</span>';
								
								} elseif(empty($task_priority)) {
								
									$priority_string = '';
								
								}
								
								?>	

								<div class="dd-task">
								
									<input class="task_weight" type="hidden" name="task_weight_<?php echo $task->ID; ?>" id="task_weight_<?php echo $task->ID; ?>" value="<?php if(!empty($weight)) { echo $weight; } else { echo $ti; } ?>" />
								
									<input class="task_id" type="hidden" name="task_weight_<?php echo $task->ID; ?>" id="task_weight_<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>" />
									
									<span class="table-task" style="display:block; float:left; margin-right:10px;"><?php _e('Task', 'cqpim'); ?></span> <span style="display:block; float:left; max-width:240px; padding-top:3px;"><strong><a href="<?php echo get_edit_post_link($task->ID); ?>"><?php echo $task->post_title; ?></a></strong> <span style="color:#999"><?php echo $task_owner; ?></span></span>
									
									<?php if(current_user_can('publish_cqpim_quotes')) { ?>
									
										<div class="dd-task-actions">
											
											<button class="delete_task" data-id="<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>"><img title="Delete Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <button class="dd-reorder" value="<?php echo $element['id']; ?>"><img title="Reorder Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/reorder.png'; ?>" /></button> <div id="ajax_spinner_<?php echo $task->ID; ?>" class="ajax_spinner" style="display:none"></div>
										
										</div>
								
									<?php } ?>
									
									<div class="dd-milestone-item-half" style="width:95px; padding-top:2px">
									
										<?php echo $task_status_string; ?>
									
									</div>
									
									<div class="dd-milestone-item-double" style="width:200px">
									
										<?php if(!empty($start)) { ?>
										
											<?php echo date(get_option('cqpim_date_format'), $start) . ' -'; ?>
										
										<?php } ?>
							
										<?php if(!empty($task_deadline)) { ?>
										
											<?php echo date(get_option('cqpim_date_format'), $task_deadline); ?>
										
										<?php } ?>								
									
									</div>
									
									<div class="clear"></div>
									
									<?php if($task_status != 'pending') { ?>
									
										<script>
											jQuery(document).ready(function() {
												jQuery( "#progressbar-<?php echo $task->ID; ?>" ).progressbar({
													value: <?php echo number_format((float)$task_pc, 2, '.', ''); ?>
												});
											});
										</script>
										
										<div class="progress <?php if($task_pc == 100 && $task_status != 'overdue') { echo 'prog-complete'; } ?> <?php if($task_pc != 100 && !empty($deadline_stamp) && $now > $deadline_stamp) { echo 'prog-overdue'; } ?>">
										
											<div id="progressbar-<?php echo $task->ID; ?>" title="<?php echo $task_pc; ?>%"></div>
										
										</div>
									
									<?php } ?>
								
								</div>
								
							<?php $ti++;
							
							} 
							
							if($ti == 0) {
							
								_e('No tasks added to this Milestone', 'cqpim');
							
							}
							
							?>
						
						</div>
					
					</div>
					
					<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
					
						<div id="delete-milestone-div-<?php echo $element['id']; ?>-container" style="display:none">
						
							<div id="delete-milestone-div-<?php echo $element['id']; ?>" class="delete-milestone-div">
							
								<div style="padding:12px">
							
									<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
								
									<p><?php _e('Deleting this milestone will also delete related tasks. Are you sure you want to do this?', 'cqpim'); ?></p>
									
									<button class="cancel_delete_stage"><?php _e('Cancel', 'cqpim'); ?></button> <button class="delete_stage" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"><?php _e('Delete', 'cqpim'); ?></button>
							
								</div>
							
							</div>
							
						</div>
					
						<div id="add-task-div-<?php echo $element['id']; ?>-container" style="display:none">
						
							<div id="add-task-div-<?php echo $element['id']; ?>" class="add-task-div">
							
								<div style="padding:12px">
							
									<h3><?php _e('Add Task', 'cqpim'); ?></h3>
									
									<input type="hidden" id="task_milestone_id_<?php echo $element['id']; ?>" name="task_milestone_id_<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>" />
									
									<input type="hidden" id="task_project_id_<?php echo $element['id']; ?>" name="task_project_id_<?php echo $element['id']; ?>" value="<?php echo $post->ID; ?>" />
								
									<input style="width:100%" type="text" name="task_title_<?php echo $element['id']; ?>" id="task_title_<?php echo $element['id']; ?>" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					

									<textarea style="width:100%;height:180px" name="task_description_<?php echo $element['id']; ?>" id="task_description_<?php echo $element['id']; ?>" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
									
									<input style="float:left" class="datepicker" type="text" name="task_start_<?php echo $element['id']; ?>" id="task_start_<?php echo $element['id']; ?>" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>	
				
									<input style="float:right" class="datepicker" type="text" name="task_finish_<?php echo $element['id']; ?>" id="task_finish_<?php echo $element['id']; ?>" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	

									<div class="clear"></div>
									
									<?php
									
									$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
									
									?>
									
									<br />
									
									<p><?php _e('If you do not assign this task to a team member, then it will be assigned to you.', 'cqpim'); ?></p>
									
									<select name="task_owner_<?php echo $key; ?>" id="task_owner_<?php echo $key; ?>">
									
										<option value=""><?php _e('Assign to', 'cqpim'); ?></option>
										
										<?php
										
										foreach($project_contributors as $contributor) {
										
											$team_details = get_post_meta($contributor, 'team_details', true);
											
											$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
									
											$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
											
											echo '<option value="' . $contributor . '">' . $team_name . ' - ' . $team_job . '</option>';
										
										}
										
										?>
									
									</select>
									
									<br /><br />
									
									<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
									
									<button class="save-task metabox-add-button" value="<?php echo $element['id']; ?>"><?php _e('Add Task', 'cqpim'); ?></button><div class="ajax_spinner" style="display:none"></div>
								
									<div class="clear"></div>
									
									<div id="task-messages-<?php echo $element['id']; ?>"></div>
								
								</div>
							
							</div>	
							
						</div>
						
						<div id="edit-milestone-<?php echo $element['id']; ?>-container" style="display:none">
					
							<div id="edit-milestone-<?php echo $element['id']; ?>" class="edit_milestone">
							
								<div style="padding:12px">
							
									<h3><?php _e('Edit Milestone', 'cqpim'); ?></h3>
								
									<input type="hidden" name="added_element_milestone_id[<?php echo $element['id']; ?>]" class="element_id" id="added_element_milestone_id[<?php echo $element['id']; ?>]" value="<?php echo $element['id']; ?>" />
								
									<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
								
									<input type="text" name="added_element_title[<?php echo $element['id']; ?>]" id="added_element_title[<?php echo $element['id']; ?>]" value="<?php echo $element['title']; ?>" />
									
									<br /><br />
															
									<span class="label"><strong><?php _e('Start Date:', 'cqpim'); ?></strong></span>

									<input class="datepicker" type="text" name="added_element_start[<?php echo $element['id']; ?>]" id="added_element_start[<?php echo $element['id']; ?>]" value="<?php if(is_numeric($element['start'])) { echo date(get_option('cqpim_date_format'), $element['start']); } else { echo $element['start']; } ?>" />

									<br /><br />
									
									<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>

									<input class="datepicker" type="text" name="added_element_finish[<?php echo $element['id']; ?>]" id="added_element_finish[<?php echo $element['id']; ?>]" value="<?php if(is_numeric($element['deadline'])) { echo date(get_option('cqpim_date_format'), $element['deadline']); } else { echo $element['deadline']; } ?>" />
														
									<br /><br />
									
									<?php if($type == 'estimate') { ?>
									
										<span class="label"><strong><?php _e('Estimated Cost:', 'cqpim'); ?></strong></span>
										
									<?php } else { ?>
									
										<span class="label"><strong><?php _e('Cost:', 'cqpim'); ?></strong></span>
										
									<?php } ?>

									<input type="text" name="added_element_cost[<?php echo $element['id']; ?>]" id="added_element_cost[<?php echo $element['id']; ?>]" value="<?php echo $element['cost']; ?>" />
														
									<br /><br />
									
									<?php $acost = isset($element['acost']) ? $element['acost'] : ''; ?>
									
									<span class="label"><strong><?php _e('Finished Cost:', 'cqpim'); ?></strong></span>
									
									<input class="finished-<?php echo $key; ?>" type="text" name="added_element_acost[<?php echo $element['id']; ?>]" id="added_element_acost[<?php echo $element['id']; ?>]" value="<?php echo $acost; ?>" />
									
									<br /><br />							
									
									<span class="label"><strong><?php _e('Status:', 'cqpim'); ?></strong></span>
									
									<select class="status-<?php echo $key; ?>" name="added_element_status[<?php echo $element['id']; ?>]" id="added_element_status[<?php echo $element['id']; ?>]">
									
										<option value="pending" <?php if(!$element['status'] || $element['status'] == 'pending') { echo 'selected="selected"'; } ?>><?php _e('Pending', 'cqpim'); ?></option>
										
										<option value="on_hold" <?php if($element['status'] == 'on_hold') { echo 'selected="selected"'; } ?>><?php _e('On Hold', 'cqpim'); ?></option>
										
										<option value="complete" <?php if($element['status'] == 'complete') { echo 'selected="selected"'; } ?>><?php _e('Complete', 'cqpim'); ?></option>
									
									</select>
									
									<?php 
									
									$checked = get_option('invoice_workflow');
									
									if($checked == 1) {
									
										echo '<p>' . __('Marking this milestone as complete will generate an invoice for the Finished cost, <br />minus the deposit percentage (if set)', 'cqpim') . '</p>';
									
									}
									
									?>
									
									<br /><br />
									
									<div id="update-ms-message-<?php echo $key; ?>"></div>
																	
									<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
									
									<button class="save metabox-add-button"><?php _e('Save', 'cqpim'); ?></button>
											
									<div class="clear"></div>
								
								</div>
								
							</div>
							
						</div>
					
					<?php } ?>
					
					<?php $i++;
				
				}
				
				echo '</div>';
				
				?>
			
			<?php }
		
		} else {
		
			_e('Please update this post before adding milestones', 'cqpim');
			
		}
		
		?>
		
		<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
		
			<?php //if(empty($quote_details['confirmed_details']['date'])) { ?>
		
				<?php if(current_user_can('cqpim_apply_project_templates')) { ?>
			
					<a href="#apply-template" id="apply-template" class="metabox-add-button colorbox"><?php _e('Apply Milestone Template', 'cqpim'); ?></a>

				<?php } ?>
				
				<a href="#add-milestone-div" id="add-milestone" class="metabox-add-button colorbox"><?php _e('Add Milestone', 'cqpim'); ?></a>
				
				<a href="#clear-all" id="clear-all" class="metabox-add-button colorbox"><?php _e('Clear All Milestones / Tasks', 'cqpim'); ?></a>
					
				<div class="clear"></div>
			
			<?php //} ?>
			
			<div id="apply-template-div-container" style="display:none">
			
				<div id="apply-template-div">
				
					<div style="padding:12px">
				
						<h3><?php _e('Apply Milestone / Task Template', 'cqpim'); ?></h3>
						
						<?php
						
						$elements = get_post_meta($post->ID, 'quote_elements', true);
						
						if(empty($elements)) {
						
							echo '<p>' . _e('Choose a template to apply Milestones and Tasks from.', 'cqpim') . '</p>';
						
						} else {
						
							echo '<p>' . _e('You already have Milestones and Tasks on this quote, applying a template will overwrite them with the contents of the template.', 'cqpim') . '</p>';						
						
						}
						
						$args = array(
						
							'post_type' => 'cqpim_templates',
							
							'posts_per_page' => -1,
							
							'post_status' => 'private'
						
						);
						
						$templates = get_posts($args);
						
						?>
						
						<select id="template_choice">
						
							<option value=""><?php _e('Choose a template...', 'cqpim'); ?></option>
						
							<?php foreach($templates as $template) { ?>
							
								<option value="<?php echo $template->ID; ?>"><?php echo $template->post_title; ?></option>
							
							<?php } ?>
						
						</select>
						
						<br /><br />
						
						<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
						
						<button id="apply-template-action" class="metabox-add-button" data-type="project" value="<?php echo $post->ID; ?>"><?php _e('Apply Template', 'cqpim'); ?></button> <div id="template_spinner" class="ajax_spinner" style="display:none"></div>

						<div class="clear"></div>
						
						<br />
						
						<div id="apply-template-messages"></div>
						
					</div>
					
				</div>
				
			</div>
			
			<div id="clear-all-div-container" style="display:none">
			
				<div id="clear-all-div">
				
					<div style="padding:12px">
				
						<h3><?php _e('Clear All', 'cqpim'); ?></h3>
						
						<p><?php _e('Are you sure you want to clear all Milestones and Tasks? This cannot be undone.', 'cqpim'); ?></p>
						
						<br /><br />
						
						<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
						
						<button id="clear-all-action" class="metabox-add-button" data-type="project" value="<?php echo $post->ID; ?>"><?php _e('Clear All', 'cqpim'); ?></button> <div id="clear_spinner" class="ajax_spinner" style="display:none"></div>
						
						<div class="clear"></div>
						
						<br />
						
						<div id="clear-all-messages"></div>

						</div>
					
				</div>
				
			</div>
		
		<div id="add-milestone-div-container" style="display:none">
		
			<div id="add-milestone-div">
			
				<div style="padding:12px">
			
					<h3><?php _e('Add Milestone', 'cqpim'); ?></h3>
				
					<input type="text" name="quote_element_title" id="quote_element_title" placeholder="<?php _e('Milestone title, eg. \'Design Phase\'', 'cqpim'); ?>"/>
				
					<input type="hidden" id="add_milestone_id" name="add_milestone_id" value="<?php echo $post->ID . '-' . $i; ?>" />
					
					<input type="hidden" id="add_milestone_order" name="add_milestone_order" value="<?php echo $i + 1; ?>" />
					
					<input class="datepicker" type="text" name="quote_element_start" id="quote_element_start" placeholder="<?php _e('Start', 'cqpim'); ?>"/>

					<input class="datepicker" type="text" name="quote_element_finish" id="quote_element_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>
					
					<?php if($type == 'estimate') { ?>
					
						<input type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Estimated Cost', 'cqpim'); ?>"/>
					
					<?php } else { ?>
					
						<input type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Cost', 'cqpim'); ?>"/>
					
					<?php } ?>
					
					<br /><br />
					
					<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
					
					<button id="add_quote_element" class="metabox-add-button"><?php _e('Add milestone to Project', 'cqpim'); ?></button> <div class="ajax_spinner" style="display:none"></div>
			
				</div>
			
			</div>	
			
		</div>
		
		<?php } ?>
		
	<?php
		
}


// Save Project Elements

add_action( 'save_post', 'save_project_elements_metabox_data' );

function save_project_elements_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['project_elements_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['project_elements_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'project_elements_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}

	$quote_elements = get_post_meta($post_id, 'project_elements', true);
	
	if(isset($_POST['added_element_title'])) {
	
		$title_array = $_POST['added_element_title'];
		
		$quote_elements = get_post_meta($post_id, 'project_elements', true);
		
		foreach($title_array as $key => $to_add) {
		
			$title = $to_add;
			
			$milestone_id = $_POST['added_element_milestone_id'][$key];
			
			$milestone_start = $_POST['added_element_start'][$key];			
			
			$milestone_start = cqpim_convert_date($milestone_start);
			
			$milestone_deadline = $_POST['added_element_finish'][$key];
			
			$milestone_deadline = cqpim_convert_date($milestone_deadline);
			
			$milestone_weight = $_POST['element_weight'][$key];
			
			$cost = $_POST['added_element_cost'][$key];
			
			$acost = $_POST['added_element_acost'][$key];
			
			$status = $_POST['added_element_status'][$key];
			
			$already_comp = $_POST['added_element_comp'][$key];
		
			$quote_elements[$key] = array(
			
				'deadline' => $milestone_deadline,
				
				'title' => $title,
				
				'start' => $milestone_start,
				
				'id' => $milestone_id,
				
				'cost' => $cost,
				
				'acost' => $acost,
				
				'status' => $status,
				
				'already_comp' => $already_comp,
				
				'weight' => $milestone_weight
			
			);
			
			if($status === 'complete') {
			
				if($quote_elements[$key]['already_comp'] != 'YES') {		
							
					$project_progress = get_post_meta($post_id, 'project_progress', true);
					
					$current_user = wp_get_current_user();
					
					if ( !($current_user instanceof WP_User) )
					  
						return;
					
					$current_user = $current_user->display_name;
					
					$text = sprintf(__('Milestone Completed: %1$s'), $title);
										
					$project_progress[] = array(
										
						'update' => $text,
											
						'date' => current_time('timestamp'),
									
						'by' => $current_user,
											
					);
										
					update_post_meta($post_id, 'project_progress', $project_progress );	

					$quote_elements[$key]['already_comp'] = 'YES';
					
					$checked = get_option('invoice_workflow');
					
					if($checked == 1) {
					
						cqpim_create_ms_completion_invoice($post_id, $quote_elements[$key]);
					
					}
				
				}
			
			}
		
		}
		
		update_post_meta($post_id, 'project_elements', $quote_elements);
		

	
	}
	
	if(isset($_POST['delete_stage'])) {
	
		$stages_to_delete = $_POST['delete_stage'];
		
		$quote_elements = get_post_meta($post_id, 'project_elements', true);
		
		foreach($stages_to_delete as $key => $delete) {
		
			unset($quote_elements[$delete]);
			
			$args = array(
						
				'post_type' => 'cqpim_tasks',
							
				'posts_per_page' => -1,
							
				'meta_key' => 'milestone_id',
							
				'meta_value' => $delete,
							
				'orderby' => 'date',
							
				'order' => 'ASC'
							
			);
						
			$tasks = get_posts($args);
						
			foreach($tasks as $task) {
						
				wp_delete_post($task->ID);		
					
			}
		
		}
		
		$new_quote_elements = array();
		
		foreach($quote_elements as $key => $element) {
		
			$new_quote_elements[$key] = $element;
		
		}
		
		update_post_meta($post_id, 'project_elements', $new_quote_elements);
	
	}

}