<?php



function support_update_metabox_callback( $post ) {


	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'support_update_metabox', 

 	 	'support_update_metabox_nonce' );
		
		//$_SESSION['times'] = 0;
		
		//echo $_SESSION['times'];
		
		$ticket_client = get_post_meta($post->ID, 'ticket_client', true);
		
		$ticket_updates = get_post_meta($post->ID, 'ticket_updates', true);
		
		$ticket_status = get_post_meta($post->ID, 'ticket_status', true);
		
		$ticket_priority = get_post_meta($post->ID, 'ticket_priority', true);
		
		?>
		
		<br />	
			
			<div class="tasks_left">
			
				<h4><?php _e('Ticket Status:', 'cqpim'); ?></h4>
		
				<select style="width:100%" id="ticket_status_new" name="ticket_status_new">
				
					<option value="open" <?php if($ticket_status == 'open') { echo 'selected="selected"'; } ?>><?php _e('Open', 'cqpim'); ?></option>
					
					<option value="resolved" <?php if($ticket_status == 'resolved') { echo 'selected="selected"'; } ?>><?php _e('Resolved', 'cqpim'); ?></option>
					
					<option value="hold" <?php if($ticket_status == 'hold') { echo 'selected="selected"'; } ?>><?php _e('On Hold', 'cqpim'); ?></option>
				
				</select>
							
			</div>
			
			<div class="tasks_right">			
			
				<h4><?php _e('Ticket Priority:', 'cqpim'); ?></h4>
					
				<select style="width:100%" id="ticket_priority_new" name="ticket_priority_new">
				
					<option value="low" <?php if($ticket_priority == 'low') { echo 'selected="selected"'; } ?>><?php _e('Low', 'cqpim'); ?></option>
					
					<option value="normal" <?php if($ticket_priority == 'normal') { echo 'selected="selected"'; } ?>><?php _e('Normal', 'cqpim'); ?></option>
					
					<option value="high" <?php if($ticket_priority == 'high') { echo 'selected="selected"'; } ?>><?php _e('High', 'cqpim'); ?></option>
					
					<option value="immediate" <?php if($ticket_priority == 'immediate') { echo 'selected="selected"'; } ?>><?php _e('Immediate', 'cqpim'); ?></option>
				
				</select>
						
			</div>
			
			<div class="clear"></div>
			
			<div class="tasks_left">
			
				<h4><?php _e('Assigned To', 'cqpim'); ?></h4>
				
				<?php

				$owner = get_post_meta($post->ID, 'ticket_owner', true);

				$args = array(
				
					'post_type' => 'cqpim_teams',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private'
				
				);
				
				$members = get_posts($args);
				
				if(empty($task_watchers)) {
				
					$task_watchers = array();
					
				}
				
				echo '<select name="ticket_owner">';
				
				echo '<option value="">' . __('Leave unassigned', 'cqpim') . '</option>';
				
				foreach($members as $member) {
				
					$team_details = get_post_meta($member->ID, 'team_details', true);

					$user = get_user_by('id', $team_details['user_id']);
					
					$caps = $user->allcaps;
					
					if(!empty($caps['cqpim_view_tickets'])) {
					
						if($member->ID == $owner) { $selected = 'selected="selected"'; } else { $selected = ''; }
				
						echo '<option value="' . $member->ID . '" ' . $selected . '> ' . $team_details['team_name'] . '</option>'; 
					
					}
				
				}
				
				echo '</select>';
				
				?>
				
				
			</div>
			
			<div class="tasks_right">
			
				<h4><?php _e('Upload Files', 'cqpim'); ?></h4>
				
				<input type="file" name="cqpim_upload_files[]" multiple>
				
			</div>
			
			<div class="clear"></div>
			
			<br /><hr />
			
			<h4><?php _e('Watchers (People other than the Assignee and client who will get update notifications)', 'cqpim'); ?></h4>				
			
			<?php

			$task_watchers = get_post_meta($post->ID, 'ticket_watchers', true);

			$args = array(
			
				'post_type' => 'cqpim_teams',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private'
			
			);
			
			$members = get_posts($args);
			
			if(empty($task_watchers)) {
			
				$task_watchers = array();
				
			}
			
			foreach($members as $member) {
			
				$team_details = get_post_meta($member->ID, 'team_details', true);

				$user = get_user_by('id', $team_details['user_id']);
				
				$caps = $user->allcaps;
				
				//print_r($caps);
				
				if(!empty($caps['cqpim_view_tickets'])) {
				
					if(in_array($member->ID, $task_watchers)) { $checked = 'checked="checked"'; } else { $checked = ''; }
			
					echo '<div class="task_watcher"><input type="checkbox" value="' . $member->ID . '" name="task_watchers[]" ' . $checked . ' /> ' . $team_details['team_name'] . '</div>'; 
				
				}
			
			}
			
			?>
			
			<br /><br /><hr /><br />
			
			<textarea style="width:100%; height:300px" name="ticket_update_new"></textarea>
			
			<div class="clear"></div>
			
			<a class="metabox-add-button save" href="#"><?php _e('Update Ticket', 'cqpim'); ?> <div id="support_spinner_1" class="ajax_loader" style="display:none"></div></a>
			
			<div class="clear"></div>
		
		<?php
		
}

// Save Ticket Update

add_action( 'save_post', 'save_support_update_metabox_data' );

function save_support_update_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['support_update_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['support_update_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'support_update_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	$data = $_POST;
	
	$files = $_FILES;
	
	$type = 'admin';
	
	$duplicate = get_post_meta($post_id, 'duplicate', true);
	
	$now = time();
	
	$diff = $now - $duplicate;
	
	if($diff > 3) {
	
		if(!empty($data['new_ticket_client'])) {
		
			$ticket_id = $post_id;
			
			$client = isset($data['new_ticket_client']) ? $data['new_ticket_client'] : '';
			
			$user = get_user_by('id', $client);
		
			$args = array(
			
				'post_type' => 'cqpim_client',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private',
				
			);
			
			$clients = get_posts($args);
			
			foreach($clients as $client) {
			
				$client_details = get_post_meta($client->ID, 'client_details', true);
				
				$client_user_id = $client_details['user_id'];
				
				if($user->ID === $client_user_id) {
				
					$client_object_id = $client->ID;
				
				}
			
			}
			
			if(empty($client_object_id)) {
			
				foreach($clients as $client) {
				
					$client_ids = get_post_meta($client->ID, 'client_ids', true);
					
					if(in_array($user->ID, $client_ids)) {
					
						$client_object_id = $client->ID;
						
						$client_type = 'contact';
					
					}
				
				} 			
			
			}
			
			$current_user = wp_get_current_user();

			$args = array(
			
				'post_type' => 'cqpim_teams',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private'
			
			);
			
			$members = get_posts($args);
			
			foreach($members as $member) {
			
				$team_details = get_post_meta($member->ID, 'team_details', true);
				
				if($team_details['user_id'] == $current_user->ID) {
				
					$assigned = $member->ID;
				
				}
			
			}
			
			$ticket_changes = array();

			if(!empty($files['cqpim_upload_files']['name'][0])) {
			
				$files_obj = array();
			
				$files_unsorted = $files['cqpim_upload_files'];
				
				foreach($files_unsorted['name'] as $key => $name) {
				
					$files_obj[$key]['name'] = $name;
				
				}
				
				foreach($files_unsorted['type'] as $key => $type) {
				
					$files_obj[$key]['type'] = $type;
				
				}
				
				foreach($files_unsorted['tmp_name'] as $key => $tmp_name) {
				
					$files_obj[$key]['tmp_name'] = $tmp_name;
				
				}
				
				foreach($files_unsorted['error'] as $key => $error) {
				
					$files_obj[$key]['error'] = $error;
				
				}
				
				foreach($files_unsorted['size'] as $key => $size) {
				
					$files_obj[$key]['size'] = $size;
				
				}
				
				$attachment_id = array();
				
				foreach($files_obj as $file) {
				
					$attachment_id[] = upload_user_file( $file, $ticket_pid );
				
				}
				
				foreach($attachment_id as $attachment) {
				
					$attachment_obj = wp_get_attachment_metadata( $attachment );
					
					update_post_meta($attachment, 'cqpim', true);
					
					$filename = str_replace('cqpim-uploads/', '', $attachment_obj['file']);
					
					$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);
				
				}		
			
			}
			
			$ticket_updates = array();
			
			$details = isset($data['ticket_update_new']) ? $data['ticket_update_new'] : '';
			
			$ticket_updates[] = array(
			
				'details' => $details,
				
				'time' => current_time('timestamp'),
				
				'name' => $current_user->display_name,
				
				'email' => $current_user->user_email,
				
				'user' => $assigned,
				
				'type' => 'admin',
				
				'changes' => $ticket_changes
				
			);
			
			update_post_meta($ticket_id, 'ticket_updates', $ticket_updates);
			
			update_post_meta($ticket_id, 'ticket_status', $data['ticket_status_new']);	
			
			update_post_meta($ticket_id, 'ticket_priority', $data['ticket_priority_new']);
			
			update_post_meta($ticket_id, 'ticket_client', $client_object_id);
			
			if(!empty($data['ticket_owner'])) {
			
				update_post_meta($ticket_id, 'ticket_owner', $data['ticket_owner']);
				
			}
			
			$watchers = isset($data['task_watchers']) ? $data['task_watchers'] : '';
			
			update_post_meta($ticket_id, 'ticket_watchers', $watchers);
			
			$last_updated = current_time('timestamp');
			
			update_post_meta($ticket_id, 'last_updated', $last_updated);

			$headers = array();
			
			$attachments = array();
			
			$sender_name = get_option('company_name');
			
			$sender_email = get_option('company_support_email');
			
			$sender_name = $sender_name;
		
			$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
		
			$headers[] = 'X-Mailer: PHP/' . phpversion();

			$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];
			
			if($data['ticket_priority_new'] == 'high' || $data['ticket_priority_new'] == 'immediate') {
			
				add_filter('phpmailer_init','update_priority_mailer');
			
			}
			
			$email_subject = get_option('client_update_ticket_subject');
				
			$email_content = get_option('client_update_ticket_email');
				
			$email_subject = cqpim_replacement_patterns($email_subject, $ticket_id, 'ticket');
				
			$email_content = cqpim_replacement_patterns($email_content, $ticket_id, 'ticket');
			
			$addresses_to_send = array();
			
			// Get client email
			
			$ticket = get_post($ticket_id);
			
			$addresses_to_send[] = array(
			
				'email' => $user->user_email,
				
				'name' => $user->display_name
				
			);
			
			// Get owner email
			
			$owner_send = get_post_meta($ticket_id, 'ticket_owner', true);
			
			$owner_details = get_post_meta($data['ticket_owner'], 'team_details', true);
			
			$owner_email = isset($owner_details['team_email']) ? $owner_details['team_email'] : '';
			
			$addresses_to_send[] = array(
			
				'email' => $owner_email,
				
				'name' => $owner_details['team_name']
				
			);
			
			// Get Watcher emails_to_send
			
			$watchers_send = get_post_meta($ticket_id, 'ticket_watchers', true);
			
			if(empty($watchers_send)) {
			
				$watchers_send = array();
				
			}
			
			foreach($watchers_send as $watcher) {
			
				$watcher_details = get_post_meta($watcher, 'team_details', true);
				
				$watcher_email = isset($watcher_details['team_email']) ? $watcher_details['team_email'] : '';
				
				$addresses_to_send[] = array(
				
					'email' => $watcher_email,
					
					'name' => $watcher_details['team_name']
					
				);
			
			}
			
			$i = 0;
			
			foreach($addresses_to_send as $address) {
			
				$name = $address['name'];
			
				${"email_content_" . $i} = str_replace('%%NAME%%', $name, $email_content);
			
				wp_mail($address['email'], $email_subject, ${"email_content_" . $i}, $headers, $attachments);
				
				$i++;
			
			}

			$ticket_updated = array(
				
				'ID' => $post_id,
					
				'post_author' => $user->ID,
					
			);
				
			if ( ! wp_is_post_revision( $post_id ) ){
				
				remove_action('save_post', 'save_support_update_metabox_data');
				
				wp_update_post( $ticket_updated );

				add_action('save_post', 'save_support_update_metabox_data');
				
			}
			
		} else {
		
			if(!empty($files['cqpim_upload_files']['name'][0])) {
			
				$files_obj = array();
			
				$files_unsorted = $files['cqpim_upload_files'];
				
				foreach($files_unsorted['name'] as $key => $name) {
				
					$files_obj[$key]['name'] = $name;
				
				}
				
				foreach($files_unsorted['type'] as $key => $type) {
				
					$files_obj[$key]['type'] = $type;
				
				}
				
				foreach($files_unsorted['tmp_name'] as $key => $tmp_name) {
				
					$files_obj[$key]['tmp_name'] = $tmp_name;
				
				}
				
				foreach($files_unsorted['error'] as $key => $error) {
				
					$files_obj[$key]['error'] = $error;
				
				}
				
				foreach($files_unsorted['size'] as $key => $size) {
				
					$files_obj[$key]['size'] = $size;
				
				}
				
				$attachment_id = array();
				
				foreach($files_obj as $file) {
				
					$attachment_id[] = upload_user_file( $file, $post_id );
				
				}
				
				foreach($attachment_id as $attachment) {
				
					$attachment_obj = wp_get_attachment_metadata( $attachment );
					
					update_post_meta($attachment, 'cqpim', true);
					
					$filename = str_replace('cqpim-uploads/', '', $attachment_obj['file']);
					
					$data['ticket_changes'][] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);
				
				}		
			
			}
		
			cqpim_update_support_ticket($post_id, $data, $files, 'admin');
			
		}
		
		update_post_meta($post_id, 'duplicate', time());
	
	}
	
}