<?php



function task_messages_metabox_callback($post) {

	wp_nonce_field( 

		'task_messages_metabox', 

		'task_messages_metabox_nonce' );
		
	$messages = get_post_meta($post->ID, 'task_messages', true);
	
	if(empty($messages)) {
	
		echo '<p>' . __('No messages to show', 'cqpim') . '</p>';
		
		echo '<h4>' . __('Add Message', 'cqpim') . '</h4>';
		
		echo '<textarea name="add_task_message"></textarea>';
		
		echo '<button class="metabox-add-button">' . __('Add Message', 'cqpim') . '</button>';
		
		echo '<div class="clear"></div>';
		
	} else {
	
		$messages = array_reverse($messages);
	
		foreach($messages as $key => $message) { 
		
			$user = get_user_by('id', $message['author']);

			$email = $user->user_email;
			
			$size = 80;
			
			$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;			
			
			?>
		
			<div class="project_message">
			
				<div class="user_avatar">
				
					<img src="<?php echo $grav_url; ?>" />
				
				</div>
				
				<div class="message_details">
				
					<h4>
					
						<?php echo $message['by']; ?>
						
						<?php
						
							echo '<button style="float:right" class="delete_message" data-id="' . $key . '" value=""><img title="Delete File" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png' . '" /></button> <div id="ajax_spinner_' . $key . '" class="ajax_spinner" style="display:none; float:right"></div>';
						
						 ?>							
						
					</h4>
					
					<span><?php echo date(get_option('cqpim_date_format') . ' H:i', $message['date']); ?></span>
					
					<div class="message">
					
						<?php echo wpautop($message['message']); ?>
					
					</div>
				
				</div>
				
				<div class="clear"></div>
			
			</div>
		
		<?php }
	
		echo '<h4>' . __('Add Message', 'cqpim') . '</h4>';
		
		echo '<textarea name="add_task_message"></textarea>';
		
		echo '<button class="metabox-add-button">' . __('Add Message', 'cqpim') . '</button>';
		
		echo '<div class="clear"></div>';
		
	}

}

add_action( 'save_post', 'save_task_messages_metabox_data' );

function save_task_messages_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['task_messages_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['task_messages_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'task_messages_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	

	
}