<?php



function team_projects_metabox_callback( $post ) {

	$args = array(
	
		'post_type' => 'cqpim_project',
		
		'posts_per_page' => -1,
		
		'post_status' => 'private',
		
		
	);				
		
	$projects = get_posts($args);
	
	if($projects) {
	
		$i = 0;
		
		echo '<table class="milestones dataTable-TPL">';
		
		echo '<thead>';
		
		echo '<th>' . __('Project Ref', 'cqpim') . '</th><th>' . __('Open Tasks', 'cqpim') . '</th><th>' . __('Progress', 'cqpim') . '</th><th>' . __('Team Members', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th>';
		
		echo '</thead>';
		
		echo '<tbody>';
	
		foreach($projects as $project) {
		
			$project_contributors = get_post_meta($project->ID, 'project_contributors', true);
			
			if(empty($project_contributors)) {
			
				$project_contributors = array();
				
			}
			
			if(in_array($post->ID, $project_contributors)) {
			
				$project_details = get_post_meta($project->ID, 'project_details', true);
				
				$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
				
				$project_edit = get_edit_post_link($project->ID);
				
				$project_elements = get_post_meta($project->ID, 'project_elements', true);
				
				if(!empty($client_id)) {
				
					if(empty($project_details['closed'])) {
					
						if(!empty($project_details['signoff'])) {
						
							$status = '<span class="task_complete">' . __('Signed Off / Completed', 'cqpim') . '</span>';
							
						} else {
						
							$checked = get_option('enable_project_contracts'); 
							
							if(!empty($checked)) {
						
								if(!empty($project_details['confirmed'])) {
								
									$status = '<span class="task_complete">' . __('Contract Signed / In Progress', 'cqpim') . '</span>';
								
								} else {
								
									if(!empty($project_details['sent'])) {
									
										$status = '<span class="task_pending">' . __('Contract Sent', 'cqpim') . '</span>';
									
									} else {
									
										$status = '<span class="task_over">' . __('Contract Not Sent', 'cqpim') . '</span>';
									
									}
								
								}
							
							} else {
								
								$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
								
							}
						
						}
						
					} else {
					
						$status = '<span style="background:#333" class="task_complete">' . __('Closed', 'cqpim') . '</span>';
						
					}
				
				} else {
				
					if(!$project_details['closed']) {
					
						$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
					
					} else {
					
						$status = '<span style="background:#333" class="task_complete">' . __('Closed', 'cqpim') . '</span>';
					
					}
				
				}
				
				$task_count = 0;
					
				$task_total_count = 0;
					
				$task_complete_count = 0;
				
				if(empty($project_elements)) {
				
					$project_elements = array();
					
				}
				
				foreach ($project_elements as $element) {
				
					$args = array(
					
						'post_type' => 'cqpim_tasks',
						
						'posts_per_page' => -1,
						
						'meta_key' => 'milestone_id',
						
						'meta_value' => $element['id'],
						
						'orderby' => 'date',
						
						'order' => 'ASC'
						
					);
					
					$tasks = get_posts($args);
					
					foreach($tasks as $task) {
					
						$task_details = get_post_meta($task->ID, 'task_details', true);
						
						$task_total_count++;
						
						$task_details = get_post_meta($task->ID, 'task_details', true);
							
						if($task_details['status'] != 'complete') {
							
							$task_count++;
							
						}
							
						if($task_details['status'] == 'complete') {
							
							$task_complete_count++;
							
						}
						
						$pc_per_task = 100 / $task_total_count;
					
						$pc_complete = $pc_per_task * $task_complete_count;
					
					}
					
				}
				
				if(empty($pc_complete)) {
				
					$pc_complete = 0;
					
				}
				
				echo '<tr>';
				
				echo '<td><a href="' . $project_edit . '" target="_blank">' . $project_details['quote_ref'] . '</a></td>';
				
				echo '<td>' . $task_count . '</td>';
				
				echo '<td>' . number_format((float)$pc_complete, 2, ".", "") . '%</td>';
				
				echo '<td>';
				
				if($project_contributors) {
				
					echo '<ul>';
				
					foreach($project_contributors as $contributor) {
					
						$team_details = get_post_meta($contributor, 'team_details', true);
						
						$team_edit = get_edit_post_link($contributor);
				
						echo '<li><a href="' . $team_edit . '" target="_blank">' . $team_details['team_name'] . '</a></li>';
				
					}
					
					echo '</ul>';
				
				}
				
				echo '</td>';
				
				echo '<td>' . $status . '</td>';
				
				echo '</tr>';						
			
			$i++;
			
			}
		
		}
		
		echo '</tbody>';
		
		echo '</table>';
		
		if($i == 0) {
		
			echo '<p style="padding:20px">' . __('This team member has not been assigned to any projects.', 'cqpim') . '</p>';
		
		}
		
	} else {
	
		echo '<p style="padding:20px">' . __('There are no active projects available', 'cqpim') . '</p>';
	
	}

}