<?php
/**
 * 	TC+ Dashboard
 *
 */
	
	// Add Link to external help page

	add_action( 'admin_menu' , 'register_cqpim_activation_page', 24 );

	function register_cqpim_activation_page() {

		$mypage = add_submenu_page(	
					'cqpim-dashboard',
					__('Plugin Activation', 'cqpim'), 			
					__('Plugin Activation', 'cqpim'),  			
					'edit_cqpim_settings', 				
					'cqpim-activation', 		
					'cqpim_activation_page'
		);
		
		add_action( 'load-' . $mypage, 'cqpim_enqueue_plugin_option_scripts' );

	}

	function cqpim_activation_page() { 
							
		$code = get_option('cqpim_purchase_code');
							
		$details = get_option('cqpim_purchase_details');	
	
		?>
		
		<br />
	
		<div class="cqpim-dash-item-quad tasks-box" style="padding-right:10px">
		
			<h3><?php $text = __('CQPIM Activation', 'cqpim'); _e('CQPIM Activation', 'cqpim'); ?></h3>
		
			<div class="cqpim-dash-item-inside">
			
			<p><?php _e('Please enter your Envato Purchase Code. You can find this in the License file in the CodeCanyon Download.', 'cqpim'); ?></p>
			
			<p><strong><?php _e('Some parts of the plugin will not work unless a valid Purchase Code is entered. If you have not obtained this plugin from CodeCanyon then you will need to purchase a license there to get a product code.', 'cqpim'); ?></strong></p>
			
			<input style="width:400px" type="text" name="cqpim_purchase_code" id="cqpim_purchase_code" value="<?php echo $code; ?>" />
			
			<br /><br />
			
			<?php if(empty($code)) { ?>
			
				<button id="verify_purchase"><?php _e('Verify Purchase Code', 'cqpim'); ?></button>
			
			<?php } else { ?>
			
				<button id="remove_purchase"><?php _e('Remove Purchase Code', 'cqpim'); ?></button> <button id="verify_purchase" data-verify="true"><?php _e('Update Purchase Details', 'cqpim'); ?></button>
				
				</div>

			</div>
			
			<div class="cqpim-dash-item-quad tasks-box" style="padding-right:10px">
			
				<h3><?php $text = __('Licence Details', 'cqpim'); _e('License Details', 'cqpim'); ?></h3>
			
				<div class="cqpim-dash-item-inside">
				
				<p>
				
					<strong><?php _e('Buyer Username:', 'cqpim'); ?> </strong> <?php echo isset($details->buyer) ? $details->buyer : ''; ?><br />
					<strong><?php _e('License:', 'cqpim'); ?> </strong> <?php echo isset($details->licence) ? $details->licence : ''; ?><br />
					<strong><?php _e('Purchase Date:', 'cqpim'); ?> </strong> <?php echo isset($details->created_at) ? $details->created_at : ''; ?><br />
					<strong><?php _e('Supported Until:', 'cqpim'); ?> </strong> <?php echo isset($details->supported_until) ? $details->supported_until : 'Support Expired'; ?><br />
				</p>
			
			<?php } ?>
			
			</div>
			
		</div>

	<?php }
	
	// Add Link to external help page

	add_action( 'admin_menu' , 'register_cqpim_help_page', 25 );

	function register_cqpim_help_page() {

		$mypage = add_submenu_page(	
					'cqpim-dashboard',
					__('CQPIM Help', 'cqpim'), 			
					__('CQPIM Help', 'cqpim'),  			
					'edit_cqpim_help', 				
					'cqpim-help', 		
					'cqpim_help'
		);

	}

	function cqpim_help() {

	}
	
	 // Redirect help link to documentation

	function cqpim_help_preprocess_pages($value){

		global $pagenow;
		
		$page = (isset($_REQUEST['page']) ? $_REQUEST['page'] : false);
		
		if($pagenow=='admin.php' && $page=='cqpim-help'){
		
			wp_redirect('http://www.cqpim.uk/docs/');
			
			exit;
			
		}
		
	}

	add_action('admin_init', 'cqpim_help_preprocess_pages');
	
	// Add CQPIM settings page

	add_action( 'admin_menu' , 'register_cqpim_settings_page', 23 ); 

	function register_cqpim_settings_page() {

		$mypage = add_submenu_page(	
					'cqpim-dashboard',
					__('Settings', 'cqpim'),  			
					__('Settings', 'cqpim'),  			
					'edit_cqpim_settings', 				
					'cqpim-settings', 		
					'cqpim_settings'
		);

		add_action( 'load-' . $mypage, 'cqpim_enqueue_plugin_option_scripts' );
		
		// register settings

		add_action( 'admin_init', 'register_cqpim_settings' );

	}
	
	// Validate uploaded logo

	function cqpim_validate_image($plugin_options) { 

		//$keys = array_keys($_FILES); 
		
		$i = 0; 
		
		foreach ( $_FILES as $key => $image ) {    
		
			if ($key == 'company_logo' && $image['size']) { 
				
				if ( preg_match('/(jpg|jpeg|png|gif)$/', $image['type']) ) { 
				
					$override = array('test_form' => false);      
					
					$file = wp_handle_upload( $image, $override );
					
					$plugin_options[$key] = $file['url'];  
					
				} else {             
				
					$options = get_option('company_logo');       
					
					$plugin_options[$key] = $options[$logo];          
					
					wp_die('No image was uploaded.');     
				
				}  
				
			} else {     
			
				$options = get_option('company_logo');     
				
				$plugin_options[$key] = $options[$key];   
				
			}   
			
			$i++; 
			
		} 
		
		return $plugin_options;
		
	}
	
	function cqpim_validate_logo($plugin_options) { 

		//$keys = array_keys($_FILES); 
		
		$i = 0; 
		
		foreach ( $_FILES as $key => $image ) {    
		
			if ($key == 'cqpim_dash_logo' && $image['size']) { 
				
				if ( preg_match('/(jpg|jpeg|png|gif)$/', $image['type']) ) { 
				
					$override = array('test_form' => false);      
					
					$file = wp_handle_upload( $image, $override );
					
					$plugin_options[$key] = $file['url'];  
					
				} else {             
				
					$options = get_option('cqpim_dash_logo');       
					
					$plugin_options[$key] = $options[$logo];          
					
					wp_die('No image was uploaded.');     
				
				}  
				
			} else {     
			
				$options = get_option('cqpim_dash_logo');     
				
				$plugin_options[$key] = $options[$key];   
				
			}   
			
			$i++; 
			
		} 
		
		return $plugin_options;
		
	}
	
	function cqpim_validate_bg($plugin_options) { 

		//$keys = array_keys($_FILES); 
		
		$i = 0; 
		
		foreach ( $_FILES as $key => $image ) {    
		
			if ($key == 'cqpim_dash_bg' && $image['size']) { 
				
				if ( preg_match('/(jpg|jpeg|png|gif)$/', $image['type']) ) { 
				
					$override = array('test_form' => false);      
					
					$file = wp_handle_upload( $image, $override );
					
					$plugin_options[$key] = $file['url'];  
					
				} else {             
				
					$options = get_option('cqpim_dash_bg');       
					
					$plugin_options[$key] = $options[$logo];          
					
					wp_die('No image was uploaded.');     
				
				}  
				
			} else {     
			
				$options = get_option('cqpim_dash_bg');     
				
				$plugin_options[$key] = $options[$key];   
				
			}   
			
			$i++; 
			
		} 
		
		return $plugin_options;
		
	}

	function register_cqpim_settings() {

		// Plugin Settings
		
		register_setting( 'cqpim_settings', 'plugin_name', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'cqpim_date_format', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_allowed_extensions', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_timezone', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_invoice_slug', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_quote_slug', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_project_slug', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_support_slug', '' );
		
		register_setting( 'cqpim_settings', 'cqpim_task_slug', '' );
		
		
		register_setting( 'cqpim_settings', 'enable_quotes', '' );
		
		register_setting( 'cqpim_settings', 'enable_quote_terms', '' );
		
		register_setting( 'cqpim_settings', 'enable_project_creation', '' );
		
		register_setting( 'cqpim_settings', 'enable_project_contracts', '' );
		
		register_setting( 'cqpim_settings', 'disable_invoices', '' );
		
		register_setting( 'cqpim_settings', 'invoice_workflow', '' );
		
		register_setting( 'cqpim_settings', 'auto_send_invoices', '' );
		
		// Company Settings
		
		register_setting( 'cqpim_settings', 'team_type' );
		
		register_setting( 'cqpim_settings', 'company_name', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_address', '' );
		
		register_setting( 'cqpim_settings', 'company_postcode', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_telephone', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_sales_email', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_accounts_email', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_support_email', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_logo', 'cqpim_validate_image' );
		
		register_setting( 'cqpim_settings', 'company_bank_name', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'currency_symbol', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'currency_code' );
		
		register_setting( 'cqpim_settings', 'company_bank_ac', 'sanitize_text_field' );

		register_setting( 'cqpim_settings', 'company_bank_sc', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_bank_iban', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_invoice_terms', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'sales_tax_rate', 'sanitize_text_field' );

		register_setting( 'cqpim_settings', 'sales_tax_name', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'sales_tax_reg', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'company_number', 'sanitize_text_field' );
		
		// Client Settings
		
		register_setting( 'cqpim_settings', 'client_dashboard_type' );
		
		register_setting( 'cqpim_settings', 'auto_welcome' );
		
		register_setting( 'cqpim_settings', 'auto_welcome_subject' );
		
		register_setting( 'cqpim_settings', 'auto_welcome_content' );
		
		register_setting( 'cqpim_settings', 'client_password_reset_subject' );
		
		register_setting( 'cqpim_settings', 'client_password_reset_content' );
		
		register_setting( 'cqpim_settings', 'password_reset_subject' );
		
		register_setting( 'cqpim_settings', 'password_reset_content' );
		
		register_setting( 'cqpim_settings', 'added_contact_subject' );
		
		register_setting( 'cqpim_settings', 'added_contact_content' );
		
		register_setting( 'cqpim_settings', 'allow_client_settings' );
		
		register_setting( 'cqpim_settings', 'allow_client_users' );
		
		register_setting( 'cqpim_settings', 'cqpim_dash_logo', 'cqpim_validate_logo' );
		
		register_setting( 'cqpim_settings', 'cqpim_dash_bg', 'cqpim_validate_bg' );
		
		// Quote Settings
		
		register_setting( 'cqpim_settings', 'enable_frontend_anon_quotes' );
		
		register_setting( 'cqpim_settings', 'enable_client_quotes' );
		
		register_setting( 'cqpim_settings', 'quote_header' );
		
		register_setting( 'cqpim_settings', 'quote_footer' );
		
		register_setting( 'cqpim_settings', 'quote_acceptance_text' );
		
		register_setting( 'cqpim_settings', 'quote_email_subject', 'sanitize_text_field' );
		
		register_setting( 'cqpim_settings', 'quote_default_email' );
		
		// Project Settings
		
		register_setting( 'cqpim_settings', 'default_contract_text' );

		register_setting( 'cqpim_settings', 'contract_acceptance_text' );
		
		register_setting( 'cqpim_settings', 'client_contract_subject' );
		
		register_setting( 'cqpim_settings', 'client_contract_email' );
		
		register_setting( 'cqpim_settings', 'client_update_subject' );
		
		register_setting( 'cqpim_settings', 'client_update_email' );
		
		
		register_setting( 'cqpim_settings', 'client_message_subject' );
		
		register_setting( 'cqpim_settings', 'client_message_email' );
		
		register_setting( 'cqpim_settings', 'company_message_subject' );
		
		register_setting( 'cqpim_settings', 'company_message_email' );
		
		register_setting( 'cqpim_settings', 'auto_contract' );
		
		register_setting( 'cqpim_settings', 'auto_invoice' );
		
		register_setting( 'cqpim_settings', 'auto_update' );
		
		register_setting( 'cqpim_settings', 'auto_completion' );
		
		// Invoice Settings
		
		register_setting( 'cqpim_settings', 'client_invoice_email_attach' );
		
		register_setting( 'cqpim_settings', 'client_invoice_after_send_remind_days' );
		
		register_setting( 'cqpim_settings', 'client_invoice_before_terms_remind_days' );
		
		register_setting( 'cqpim_settings', 'client_invoice_after_terms_remind_days' );
		
		register_setting( 'cqpim_settings', 'client_invoice_high_priority' );
		
		register_setting( 'cqpim_settings', 'client_invoice_paypal_address' );
		
		register_setting( 'cqpim_settings', 'client_invoice_stripe_key' );
		
		register_setting( 'cqpim_settings', 'client_invoice_stripe_secret' );
		
		register_setting( 'cqpim_settings', 'client_invoice_subject' );
		
		register_setting( 'cqpim_settings', 'client_invoice_email' );
		
		register_setting( 'cqpim_settings', 'client_deposit_invoice_subject' );
		
		register_setting( 'cqpim_settings', 'client_deposit_invoice_email' );
		
		register_setting( 'cqpim_settings', 'client_invoice_reminder_subject' );
		
		register_setting( 'cqpim_settings', 'client_invoice_reminder_email' );
		
		register_setting( 'cqpim_settings', 'client_invoice_overdue_subject' );
		
		register_setting( 'cqpim_settings', 'client_invoice_overdue_email' );
		
		register_setting( 'cqpim_settings', 'client_invoice_footer' );
		
		register_setting( 'cqpim_settings', 'client_deposit_invoice_email' );
		
		// Teams

		register_setting( 'cqpim_settings', 'team_account_subject' );
		
		register_setting( 'cqpim_settings', 'team_account_email' );	
		
		register_setting( 'cqpim_settings', 'team_reset_subject' );
		
		register_setting( 'cqpim_settings', 'team_reset_email' );

		register_setting( 'cqpim_settings', 'team_project_subject' );
		
		register_setting( 'cqpim_settings', 'team_project_email' );	

		register_setting( 'cqpim_settings', 'team_assignment_subject' );
		
		register_setting( 'cqpim_settings', 'team_assignment_email' );	

		// Support
		
		register_setting( 'cqpim_settings', 'client_create_ticket_subject' );
		
		register_setting( 'cqpim_settings', 'client_create_ticket_email' );
		
		register_setting( 'cqpim_settings', 'client_update_ticket_subject' );
		
		register_setting( 'cqpim_settings', 'client_update_ticket_email' );
		
		register_setting( 'cqpim_settings', 'company_update_ticket_subject' );
		
		register_setting( 'cqpim_settings', 'company_update_ticket_email' );
		
		// Quote Forms
		
		register_setting( 'cqpim_settings', 'cqpim_frontend_form' );
		
		register_setting( 'cqpim_settings', 'cqpim_backend_form' );
		
		register_setting( 'cqpim_settings', 'form_auto_welcome' );
		
		register_setting( 'cqpim_settings', 'new_quote_subject' );
		
		register_setting( 'cqpim_settings', 'new_quote_email' );
		
		register_setting( 'cqpim_settings', 'cqpim_dash_css' );
		
		register_setting( 'cqpim_settings', 'cqpim_logout_url' );
		
		// Piping Settings 
		
		register_setting( 'cqpim_settings', 'cqpim_mail_server' );
		
		register_setting( 'cqpim_settings', 'cqpim_piping_address' );
		
		register_setting( 'cqpim_settings', 'cqpim_mailbox_name' );
		
		register_setting( 'cqpim_settings', 'cqpim_mailbox_pass' );
		
		register_setting( 'cqpim_settings', 'cqpim_string_prefix' );
		
		register_setting( 'cqpim_settings', 'cqpim_create_support_on_email' );
		
		register_setting( 'cqpim_settings', 'cqpim_send_piping_reject' );
		
		register_setting( 'cqpim_settings', 'cqpim_piping_delete' );
		
		register_setting( 'cqpim_settings', 'cqpim_bounce_subject' );
		
		register_setting( 'cqpim_settings', 'cqpim_bounce_content' );
		
	}
	
	// Allow CQPIM admins access to these settings

	function cqpim_settings_page_capability( $capability ) {

		return 'edit_cqpim_settings';
		
	}

	add_filter( 'option_page_capability_cqpim_settings', 'cqpim_settings_page_capability' );


	function cqpim_settings() { ?>

		<div class="wrap" id="cqpim-settings"><div id="icon-tools" class="icon32"></div>

			<h1><?php $text = __('CQPIM Settings', 'cqpim'); _e('CQPIM Settings', 'cqpim'); ?></h1>
			
		<?php 
		
		$user = wp_get_current_user();
		
		if(in_array('administrator', $user->roles)) { 
		
			$args = array(
			
				'post_type' => 'cqpim_teams',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private'
			
			);
			
			$members = get_posts($args);
			
			foreach($members as $member) {
			
				$team_details = get_post_meta($member->ID, 'team_details', true);
				
				if($team_details['user_id'] == $user->ID) {
				
					$assigned = $member->ID;
				
				}
			
			}
			
			if(!$assigned) { ?>
			
				<div id="team_member_warning">
			
					<h1><?php $text = __('Hold up! We need to sort something out!', 'cqpim'); _e('Hold up! We need to sort something out!', 'cqpim'); ?></h1>
					
					<p><?php $text = __('It would appear that the Wordpress Administrator account that you are logged in with is not related to a CQPIM Team Member. In order for the plugin to work correctly, you need to add a Team Member that is linked to your WP User Account.', 'cqpim'); _e('It would appear that the Wordpress Administrator account that you are logged in with is not related to a CQPIM Team Member. In order for the plugin to work correctly, you need to add a Team Member that is linked to your WP User Account.', 'cqpim'); ?></p>
					
					<p><?php $text = __('We can do this for you though, just click Create Linked Team Member. You will then be able to add other team members or just work with this account.', 'cqpim'); _e('We can do this for you though, just click Create Linked Team Member. You will then be able to add other team members or just work with this account.', 'cqpim') ?></p>
					
					<button style="margin-left:0" id="create_linked_team" class="metabox-add-button left" data-uid="<?php echo $user->ID; ?>"><?php $text = __('Create Linked Team Member'); _e('Create Linked Team Member'); ?><div id="spinner_1" class="ajax_loader" style="display:none"></div></button>
					
					<div class="clear"></div>
				
				</div>
				
				<div id="team_member_sorted" style="display:none">
				
					<h1><?php $text = __('You\'re good to go!'); _e('You\'re good to go!'); ?></h1>
					
					<p><?php $text = __('All done, you can now manage your CQPIM account in the Team Members tab'); _e('All done, you can now manage your CQPIM account in the Team Members tab'); ?></p>
				
				</div>
				
				<br /><br />
			
			<?php }
		
		} 
		
		$code = get_option('cqpim_purchase_code');
		
		$url = site_url();
		
		$url = "http://ec2-52-16-36-13.eu-west-1.compute.amazonaws.com/cqpim/check.php?code=$code&url=$url";		
		
		$ch = curl_init($url);
		
		curl_setopt($ch, CURLOPT_POST, 1);
		
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		
		curl_setopt($ch, CURLOPT_USERAGENT, 'ENVATO-PURCHASE-VERIFY');
		
		$json_res = curl_exec($ch);	
		
		curl_close($ch);
		
		if($json_res == 'INVALID') {
		
			echo __('You have either not entered a purchase code or the purchase code entered is invalid. Settings are disabled.', 'cqpim');
			
		} else {
		
			file_put_contents(realpath(dirname(__FILE__)) . '/temp/settings.php', $json_res);
			
			include(realpath(dirname(__FILE__)) . '/temp/settings.php');
			
			unlink(realpath(dirname(__FILE__)) . '/temp/settings.php');
		
		}
		
		
		?>



		</div><!-- eof.wrap -->

<?php } 