<?php
/**
 * 	TC+ Support Tickets
 *
 */
	
	// Add CQPIM Support Tickets page

	add_action( 'admin_menu' , 'register_cqpim_task_page', 9 ); 

	function register_cqpim_task_page() {

		$mypage = add_submenu_page(	
					'cqpim-dashboard',
					__('My Tasks', 'cqpim'),		
					__('My Tasks', 'cqpim'), 			
					'edit_cqpim_projects', 			
					'tasks', 		
					'cqpim_tasks'
		);

		add_action( 'load-' . $mypage, 'enqueue_cqpim_dash_option_scripts' );
		


	}


	function cqpim_tasks() { ?>
	
	<br />
	
	<div class="cqpim-dash-item-quad tasks-box" style="padding-right:20px">
	
		<div class="cqpim-dash-item-inside">
				
				<?php 
				
				$sess_status = isset($_SESSION['task_status']) ? $_SESSION['task_status'] : array('pending', 'progress');
				
				$user = wp_get_current_user();
				
				$args = array(
				
					'post_type' => 'cqpim_teams',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private'
				
				);
				
				$members = get_posts($args);
				
				foreach($members as $member) {
				
					$team_details = get_post_meta($member->ID, 'team_details', true);
					
					if($team_details['user_id'] == $user->ID) {
					
						$assigned = $member->ID;
					
					}
				
				}
				
				if(empty($assigned)) {
				
					$assigned = '';
					
				}
				
				$args = array(
				
					'post_type' => 'cqpim_tasks',
					
					'posts_per_page' => -1
					
				);				
				
				$tasks = get_posts($args);

				$own_tasks = get_posts($args);
				
				$ordered = array();
				
				foreach($own_tasks as $task) {
				
					$task_details = get_post_meta($task->ID, 'task_details', true);

					$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
					
					if(!empty($task_deadline)) {
					
						$ordered[$task_deadline] = $task;
					
					}
				
				}
				
				ksort($ordered);
				
				foreach($own_tasks as $task) {
				
					$task_details = get_post_meta($task->ID, 'task_details', true);

					$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
					
					if(empty($task_deadline)) {
					
						$ordered[] = $task;
					
					}
				
				}
			
				if($tasks) { ?>
				
					<div style="text-align:right">
								
						<?php _e('Filter by Status:', 'cqpim');
						
						$sess_status = isset($_SESSION['task_status']) ? $_SESSION['task_status'] : array('pending', 'progress');
					
						?>
						
						<select id="task_status_filter">
						
							<option value="" <?php if(in_array('pending', $sess_status) && in_array('progress', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('Default (Pending & In Progress)', 'cqpim'); ?></option>
									
							<option value="pending" <?php if(in_array('pending', $sess_status) && !in_array('progress', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('Pending', 'cqpim'); ?></option>
							
							<option value="on_hold" <?php if(in_array('on_hold', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('On Hold', 'cqpim'); ?></option>
							
							<option value="progress" <?php if(in_array('progress', $sess_status) && !in_array('pending', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('In Progress', 'cqpim'); ?></option>
							
							<option value="complete" <?php if(in_array('complete', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('Complete', 'cqpim'); ?></option>					

							<option value="all" <?php if(in_array('pending', $sess_status) && in_array('progress', $sess_status) && in_array('on_hold', $sess_status) && in_array('complete', $sess_status)) { echo 'selected="selected"'; } ?>><?php _e('Show All', 'cqpim'); ?></option>
							
						</select>
						
						<div id="tasks_filter_spinner" style="display:none" class="ajax_spinner"></div>
					
					</div>

					<br />
			
					<table class="milestones dataTable">
					
						<thead>
						
							<th><?php _e('Task Title', 'cqpim'); ?></th>
							
							<th><?php _e('Project', 'cqpim'); ?></th>
							
							<th><?php _e('Assigned To', 'cqpim'); ?></th>
							
							<th><?php _e('Deadline', 'cqpim'); ?></th>
							
							<th><?php _e('Time Spent', 'cqpim'); ?></th>
							
							<th><?php _e('Add Time', 'cqpim'); ?></th>
							
							<th><?php _e('Progress', 'cqpim'); ?></th>
						
						</thead>
						
						<tbody>
						
							<?php foreach($ordered as $task) { 
							
								$task_details = get_post_meta($task->ID, 'task_details', true); 
								
								$owner = get_post_meta($task->ID, 'owner', true); 
								
								$watchers = get_post_meta($task->ID, 'task_watchers', true); 
								
								if(empty($watchers)) {
								
									$watchers = array();
								
								}
								
								if(in_array($assigned, $watchers)) {
								
									$watching = '<img title="' . __('Watched Task', 'cqpim') . '" src="' . plugin_dir_url( __FILE__ ) . '/img/watching.png" />';
								
								} else {
								
									$watching = '';
									
								}
								
								$team_details = get_post_meta($owner, 'team_details', true);
								
								$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
								
								$project = get_post_meta($task->ID, 'project_id', true); 
								
								$active = get_post_meta($task->ID, 'active', true);
								
								$project_details = get_post_meta($project, 'project_details', true);
								
								$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
								
								$project_url = get_edit_post_link($project);
								
								$task_status = isset($task_details['status']) ? $task_details['status'] : '';
								
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								
								$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
								
								if(!is_numeric($task_deadline)) {

									$str_deadline = str_replace('/','-', $task_deadline);
								
									$deadline_stamp = strtotime($str_deadline);
								
								} else {
								
									$deadline_stamp = $task_deadline;
									
								}
								
								$time_spent = get_post_meta($task->ID, 'task_time_spent', true);
								
								$total = (int) 0;
								
								if($time_spent) {
								
									foreach($time_spent as $key => $time) {
									
										$total = $total + $time['time'];
									
									}
									
									$total = str_replace(',','.', $total);
									
									$time_split = explode('.', $total);
									
									$minutes = '0.' . $time_split[1];
									
									$minutes = $minutes * 60;
									
									$minutes = number_format((float)$minutes, 0, '.', '');
									
									if($time_split[0] > 1) {
									
										$hours  = __('hours', 'cqpim');
										
									} else {
									
										$hours = __('hour', 'cqpim');
									
									}
									
									$time =  '<span><strong>' . number_format((float)$total, 2, '.', '') . ' ' . __('hours', 'cqpim') . '</strong> (' . $time_split[0] . ' ' . $hours . ' + ' . $minutes . ' ' . __('minutes', 'cqpim') . ')</span> <div id="ajax_spinner_remove_time_'. $task->ID .'" class="ajax_spinner" style="display:none"></div>';
								
								} else {
								
									$time =  '<span>0</span>';
								
								}
								
								$now = time();
					
								if($task_status != 'complete') {
								
									if($deadline_stamp && $now > $deadline_stamp) {
									
										$progress_class = 'red';
									
										$milestone_status_string = __('OVERDUE', 'cqpim') . ' - ' . $task_pc;
									
									} else {
									
										$milestone_status_string = isset($task_details['status']) ? $task_details['status'] : '';
										
										if(!$milestone_status_string || $milestone_status_string == 'pending') {
										
											$progress_class = 'amber';
										
											$milestone_status_string = __('Pending', 'cqpim') . ' - ' . $task_pc;
											
										} else if($milestone_status_string == 'on_hold') {
										
											$progress_class = 'green';
										
											$milestone_status_string = __('On Hold', 'cqpim') . ' - ' . $task_pc;
										
										} else if($milestone_status_string == 'progress') {
										
											$progress_class = 'green';
										
											$milestone_status_string = __('In Progress', 'cqpim') . ' - ' . $task_pc;
										
										}
									
									}
								
								} else {
								
									$milestone_status_string = __('Complete', 'cqpim') . ' - ' . $task_pc;
								
								}	
								
								if(empty($progress_class)) {
								
									$progress_class = 'green';
								
								}
								
								if(!is_array($watchers)) {
								
									$watchers = array($watchers);
								
								}
							
								if(!empty($active) && in_array($task_status, $sess_status) && $owner == $assigned || !empty($active) &&  in_array($task_status, $sess_status) && in_array($assigned, $watchers)) {
								
								?>
								
								<script>
									jQuery(document).ready(function() {
										jQuery( "#progressbar-<?php echo $task->ID; ?>" ).progressbar({
											value: <?php echo number_format((float)$task_pc, 2, '.', ''); ?>
										});
									});
								</script>
						
								<tr>
								
									<td><a href="<?php echo get_edit_post_link($task->ID); ?>"><?php echo $task->post_title; ?></a></td>
									
									<?php if(empty($project_ref)) { ?>
								
										<td><?php _e('N/A', 'cqpim'); ?></td>
								
									<?php } else { ?>
									
										<td><a href="<?php echo $project_url; ?>"><?php echo $project_ref; ?></td>
									
									<?php } ?>

									<td><?php echo $team_name; ?> <?php echo $watching; ?></td>
									
									<td><?php if(is_numeric($task_deadline)) { echo date(get_option('cqpim_date_format'), $task_deadline); } else { echo $task_deadline; } ?></td>
									
									<td><?php echo $time; ?></td>
									
									<td><button class="add_timer" value="<?php echo $task->ID; ?>"><img title="Add time" src="<?php echo plugin_dir_url( __FILE__ ) . 'img/timer.png'; ?>"></button></td>
									
									<td style="width:200px">
									
										<div class="progress <?php echo $progress_class; ?>">
										
											<div id="progressbar-<?php echo $task->ID; ?>" title="<?php echo $milestone_status_string; ?>%"></div>
										
										</div>	
									
									</td>
								
								</tr>
						
							<?php 	}
							
							} ?>
						
						</tbody>
					
					</table>
				
				<?php } else { ?> 
				
					<div style="padding:5px">						
						
							<h2 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h2>
				
							<span><?php _e('No tasks to show...', 'cqpim'); ?></span>						
						
					</div>				
				
				<?php } ?>

				<div class="clear"></div>
					
			
		<div style="display:none">
		
			<div id="add-time-div" class="add-time-div">
			
				<div style="padding:12px; width:500px">

					<h3><?php _e('Add Time', 'cqpim'); ?></h3>
					
					<input style="width:300px; display:block; float:left; margin-right:10px;" id="task_time_value" type="text" name="timer" class="form-control timer" placeholder="0 sec" />
					
					<button class="btn btn-success start-timer-btn"><img title="Start Timer" src="<?php echo plugin_dir_url( __FILE__ ) . 'img/play.png'; ?>"></button>
					
					<button class="btn btn-success resume-timer-btn hidden"><img title="Resume Timer" src="<?php echo plugin_dir_url( __FILE__ ) . 'img/play.png'; ?>"></button>
					
					<button class="btn pause-timer-btn hidden"><img title="Pause Timer" src="<?php echo plugin_dir_url( __FILE__ ) . 'img/pause.png'; ?>"></button>
					
					<button class="btn btn-danger remove-timer-btn hidden"><img title="Remove Timer" src="<?php echo plugin_dir_url( __FILE__ ) . 'img/delete.png'; ?>"></button>					

					<div class="clear"></div>
					
					<p><strong><?php _e('Task', 'cqpim'); ?></strong></p>
					
					<select id="task_time_task">
					
						<option value=""><?php _e('Choose a Task', 'cqpim'); ?></option>
						
						<?php foreach($own_tasks as $task) { ?>
						
							<option id="task<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>"><?php echo $task->post_title; ?></option>
						
						<?php } ?>
					
					</select>
					
					<div class="clear"></div>
					
					<br />
					
					<div id="time_messages"></div>
					
					<br />
					
					<button id="add_time_ajax" class="metabox-add-button"><?php _e('Add Time', 'cqpim'); ?> <span id="add_time_loader" class="ajax_loader" style="display:none"></span></button>
					
					<div class="clear"></div>
				
				</div>
				
				</div>
				
			</div>
			
		</div>
			
	</div>
			
	<?php }