<?php	
	
	$form = get_option('cqpim_backend_form');

	$form_data = get_post_meta($form, 'builder_data', true);
	
	if(!empty($form_data)) {

		$form_data = json_decode($form_data);

		$fields = $form_data->fields;
	
	}

	echo '<form id="cqpim_backend_form">';

	if(!empty($fields)) {

		echo '<div id="cqpim_backend_quote">';
		
		//echo '<pre>';
		
		//print_r($fields);
		
		//echo '</pre>';

		foreach($fields as $field) {
		
			$id = strtolower($field->label);
			
			$id = str_replace(' ', '_', $id);
			
			$id = str_replace('-', '_', $id);
			
			$id = str_replace(':', '', $id);
			
			$id = str_replace('(', '', $id);
			
			$id = str_replace(')', '', $id);
			
			if($field->required == 1) {
			
				$required = 'required';
				
				$ast = '<span style="color:#F00">*</span>';
				
			} else {
			
				$required = '';
				
				$ast = '';
				
			}
			
			echo '<div style="padding-bottom:12px" class="cqpim_form_item">';
			
			echo '<label style="display:block; padding-bottom:5px" for="' . $id . '">' . $field->label . ' ' . $ast . '</label>';
		
			if($field->field_type == 'text') {
			
				echo '<input type="text" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'website') {
			
				echo '<input type="url" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'number') {
			
				echo '<input type="number" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'paragraph') {
			
				echo '<textarea id="' . $id . '" ' . $required . '></textarea>';
			
			} elseif($field->field_type == 'date') {
			
				echo '<input type="date" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'email') {
			
				echo '<input type="email" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'checkboxes') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				foreach($options as $option) {
				
					$value = strtolower($option->label);
					
					$value = str_replace(' ', '_', $value);
			
					echo '<input type="checkbox" value="' . $value . '" name="' . $id . '" /> ' . $option->label . '<br />';
					
				}
			
			} elseif($field->field_type == 'radio') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				foreach($options as $option) {
				
					$value = strtolower($option->label);
					
					$value = str_replace(' ', '_', $value);
			
					echo '<input type="radio" value="' . $value . '" name="' . $id . '" ' . $required . ' /> ' . $option->label . '<br />';
					
				}
			
			} elseif($field->field_type == 'dropdown') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				echo '<select id="' . $id . '" ' . $required . '>';
				
					foreach($options as $option) {
					
						$value = strtolower($option->label);
						
						$value = str_replace(' ', '_', $value);
				
						echo '<option value="' . $value . '">' . $option->label . '</option>';
						
					}
				
				echo '</select>';
			
			}
			
			echo '</div>';
		
		}
		
		echo '<br />';
		
		echo '<input type="submit" id="cqpim_submit_backend" value="' . __('Submit Quote Request', 'cqpim') . '" /><br /><div id="form_spinner" style="clear:both; display:none; background:url(' . plugins_url() . '/cqpim/css/img/ajax-loader.gif) center center no-repeat; width:16px; height:16px; padding:10px 0 0 5px; margin-top:15px"></div>';

		echo '<div style="margin-top:20px" id="cqpim_submit_backend_messages"></div>';
		
		echo '</div>';
		
	} else {

		echo '<p>' . __('You have not added any fields to the selected form', 'cqpim') . '</p>';
		
	}

	echo '</form>';	
	
	echo '<input type="hidden" id="client" value="' . $assigned . '" />';
	
	?>

	<script type="text/javascript">
	
		jQuery(document).ready(function() {
						
			jQuery('#cqpim_backend_form').on('submit', function(e) {
			
				e.preventDefault();
				
				var spinner = jQuery('#form_spinner');
				
				var client = jQuery('#client').val();
				
				<?php
				
				if(empty($fields)) {
				
					$fields = array();
					
				}
				
				foreach($fields as $field) {
				
					$id = strtolower($field->label);
					
					$id = str_replace(' ', '_', $id);
					
					$id = str_replace('-', '_', $id);
					
					$id = str_replace(':', '', $id);
					
					$id = str_replace('(', '', $id);
					
					$id = str_replace(')', '', $id);	

					if($field->field_type == 'text' || 
					
						$field->field_type == 'number' || 
						
						$field->field_type == 'email' || 
						
						$field->field_type == 'paragraph' ||
						
						$field->field_type == 'website' || 
						
						$field->field_type == 'dropdown' || 
						
						$field->field_type == 'date' || 
						
						$field->field_type == 'number') {
					
						echo 'var ' . $id . ' = jQuery("#' . $id . '").val();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';
					
					} elseif($field->field_type == 'checkboxes') {

						echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").map(function() { return jQuery(this).val(); }).get();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

					} elseif($field->field_type == 'radio') {

						echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").val();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

					}
				
				}
				
				?>
				
				var data = {
				
					'action' : 'cqpim_backend_quote_submission',
					
					'client' : client,
				
					<?php
					
					foreach($fields as $field) {
					
						$id = strtolower($field->label);
						
						$id = str_replace(' ', '_', $id);
						
						$id = str_replace('-', '_', $id);
						
						$id = str_replace(':', '', $id);
						
						$id = str_replace('(', '', $id);
						
						$id = str_replace(')', '', $id);

						echo "'" . $id . "' : " . $id . ",";
					
					}
					
					?>
				
				};
				
				jQuery.ajax({

					url: '<?php echo admin_url() . 'admin-ajax.php'; ?>',

					data: data,

					type: 'POST',

					dataType: 'json',

					beforeSend: function(){

						// show spinner

						spinner.show();

						// disable form elements while awaiting data

						jQuery('#cqpim_submit_backend').prop('disabled', true);

					},

				}).done(function(response){
				
					if(response.error == true) {
					
						spinner.hide();

						// re-enable form elements so that new enquiry can be posted

						jQuery('#cqpim_submit_backend').prop('disabled', false);
					
						jQuery('#cqpim_submit_backend_messages').html(response.message);
						
					} else {

						spinner.hide();

						// re-enable form elements so that new enquiry can be posted

						jQuery('#cqpim_submit_backend').prop('disabled', false);
						
						jQuery('#cqpim_submit_backend_messages').html(response.message);
					
					}

				});
			
			});
		
		});
	
	</script>